#include <stdio.h>
#include <math.h>

int IntHand(void);

extern unsigned long VsyncCount;
extern unsigned long NOHLE;
extern unsigned long hardDMA;

extern unsigned long hardInterrupt;
extern unsigned long temporizer;
extern unsigned long tempohsync;
extern unsigned long NextRTC0 asm("_NextRTC0");
extern unsigned long NextRTC1 asm("_NextRTC1");
extern unsigned long NextRTC2 asm("_NextRTC2");
extern unsigned long cdV asm("_cdV");
extern unsigned long InstrCountHoriz;
extern unsigned long VerticalLine;

extern unsigned char pad1d[5];
extern unsigned char pad2d[5];

void GPU__writeStatus(unsigned long data);
void GPU__writeData(unsigned long data);
void GPU__writeDataMem(unsigned long * pMem, unsigned long iSize);

void (*WCD[4])(unsigned long rt);
unsigned long (*RCD[4])(void);
void (*doDMA[7])(unsigned long rt);

typedef struct {
	unsigned long cpr2[32];
	unsigned long ccr2[32];
} R3000_REG;

#define	regCOP2D regg.cpr2
#define	regCOP2C regg.ccr2

#define psxSL ((unsigned long*)psxS)
#define psxSLS ((signed long*)psxS)
#define psxSW ((unsigned short*)psxS)
#define psxSWS ((signed short*)psxS)

#define psxHL ((unsigned long*)psxH)
#define psxHLS ((signed long*)psxH)
#define psxHW ((unsigned short*)psxH)
#define psxHWS ((signed short*)psxH)

#define psxML ((unsigned long*)psxM)
#define psxMLS ((signed long*)psxM)
#define psxMW ((unsigned short*)psxM)
#define psxMWS ((signed short*)psxM)

#define psxRL ((unsigned long*)psxR)
#define psxRLS ((signed long*)psxR)
#define psxRW ((unsigned short*)psxR)
#define psxRWS ((signed short*)psxR)

#define regS ((signed long*)reg)

extern int NEWGPU;
extern int CDDEC;

extern unsigned long rPC asm("rPC");
extern unsigned long reg[32];
extern unsigned long regCOP0[32];
extern R3000_REG regg asm("_regg");
extern signed long regLO asm("_regLO");
extern signed long regHI asm("_regHI");
extern unsigned long *psxMEM[0x10000] asm("_psxMEM");
extern unsigned long *psxMEMW[0x10000] asm("_psxMEMW");

extern unsigned char psxM[2*1024*1034] asm("psxM");
extern unsigned char psxH[64*1024] asm("psxH");

#define regZR reg[0x00]
#define regAT reg[0x01]
#define regV0 reg[0x02]
#define regV1 reg[0x03]
#define regA0 reg[0x04]
#define regA1 reg[0x05]
#define regA2 reg[0x06]
#define regA3 reg[0x07]
#define regT0 reg[0x08]
#define regT1 reg[0x09]
#define regT2 reg[0x0a]
#define regT3 reg[0x0b]
#define regT4 reg[0x0c]
#define regT5 reg[0x0d]
#define regT6 reg[0x0e]
#define regT7 reg[0x0f]
#define regS0 reg[0x10]
#define regS1 reg[0x11]
#define regS2 reg[0x12]
#define regS3 reg[0x13]
#define regS4 reg[0x14]
#define regS5 reg[0x15]
#define regS6 reg[0x16]
#define regS7 reg[0x17]
#define regT8 reg[0x18]
#define regT9 reg[0x19]
#define regK0 reg[0x1a]
#define regK1 reg[0x1b]
#define regGP reg[0x1c]
#define regSP reg[0x1d]
#define regFP reg[0x1e]
#define regRA reg[0x1f]

int cop2(int code,R3000_REG *r);
void rtv0(R3000_REG *r);
void rtir(R3000_REG *r);
void rtir0(R3000_REG *r);
void RTPT(R3000_REG *r);
void RTPS(R3000_REG *r);
void NCLIP(R3000_REG *r);
void NCCT(R3000_REG *r);
void op12(R3000_REG *r);
void AVSZ3(R3000_REG *r);
void LZCR_read(R3000_REG *r);

#define GetAdressR(adr) (void*)psxMEM[(adr>>16)&0xffff]+(adr&0xffff);
#define GetAdressW(adr) (void*)psxMEMW[(adr>>16)&0xffff]+(adr&0xffff);

#include "ahle.h"

int HLE_0001(void)
{
 register int *Pointer0;

 Pointer0= GetAdressR(regA0);
 regCOP2C[0]= Pointer0[0];
 regCOP2C[1]= Pointer0[1];
 regCOP2C[2]= Pointer0[2];
 regCOP2C[3]= Pointer0[3];
 regCOP2C[4]= Pointer0[4];

 Pointer0= GetAdressR(regA1);
 regCOP2D[0]= Pointer0[0];
 regCOP2D[1]= Pointer0[1];

 rtv0(&regg);

 Pointer0= GetAdressW(regA2);
 Pointer0[0]=regCOP2D[25];
 Pointer0[1]=regCOP2D[26];
 Pointer0[2]=regCOP2D[27];
 regV0=regA2;
 rPC=regRA;
 return(40);
}

int HLE_0002(void)
{
 register int *Pointer0;

 Pointer0= GetAdressR(regA0);
 regCOP2D[0]= Pointer0[0];
 regCOP2D[1]= Pointer0[1];

 Pointer0= GetAdressR(regA1);
 regCOP2D[2]= Pointer0[0];
 regCOP2D[3]= Pointer0[1];

 Pointer0= GetAdressR(regA2);
 regCOP2D[4]= Pointer0[0];
 regCOP2D[5]= Pointer0[1];

 RTPT(&regg);

 Pointer0= GetAdressR(regSP);
 regT0= Pointer0[4];
 regT1= Pointer0[5];
 regT2= Pointer0[6];
 regT3= Pointer0[7];

 Pointer0= GetAdressW(regA3);
 Pointer0[0]=regCOP2D[12];

 Pointer0= GetAdressW(regT0);
 Pointer0[0]=regCOP2D[13];

 Pointer0= GetAdressW(regT1);
 Pointer0[0]=regCOP2D[14];

 if (regCOP2C[31]&0x7f87e000) regCOP2C[31]|=(1<<31); else regCOP2C[31]&=(1<<31);
 regT0=regCOP2C[31];

 Pointer0= GetAdressW(regT2);
 Pointer0[0]=regCOP2D[8];

 Pointer0= GetAdressW(regT3);
 Pointer0[0]=regT0;

 AVSZ3(&regg);

 regV0=regCOP2D[7];

 rPC=regRA;
 return(44);
}

int HLE_0003(void)
{
 register int *Pointer0;
 register int *Pointer1;

 Pointer0= GetAdressR(regA1);
 Pointer1= GetAdressW(regA0);
 Pointer1[5]=Pointer0[0];
 Pointer1[6]=Pointer0[1];
 Pointer1[7]=Pointer0[2];
 regV0=regA0;
 rPC=regRA;
 return(18);
}

int HLE_0004(void)
{
 signed short *Pointer0;

 regCOP2D[30]=regA0;

 LZCR_read(&regg);
 regV0=regCOP2D[31];

 regAT=0x20;
 if (regV0==regAT) { regV0=0; rPC=regRA; return(18); }

 regT0=regV0&1;
 regT2=regV0&0xfffffffe;
 regT1=(signed long)(0x1f-regT2)>>1;
 regT3=regT2+0xffffffe8;

 if ((signed long)regT3 < 0) { regT3=0x18-regT2; regT4=(signed long)regA0>>regT3; }
 else { regT4=regA0<<regT3; regT3=0x18; }

 regT4=(regT4+0xffffffc0)<<1;
 regT5=0x80050000+0xffff98dc+regT4;

 Pointer0=GetAdressR(regT5);
 regT5=Pointer0[0];
 regT5=regT5<<regT1;
 regV0=regT5>>0xc;
 rPC=regRA;
 return(66);
}

int HLE_0005(void)
{
 unsigned long *Pointer0;
 unsigned long *Pointer1;

 Pointer0=GetAdressR(regA0);
 regCOP2D[0]=Pointer0[0];
 regCOP2D[1]=Pointer0[1];
 Pointer0=GetAdressR(regA1);
 regCOP2D[2]=Pointer0[0];
 regCOP2D[3]=Pointer0[1];
 Pointer0=GetAdressR(regA2);
 regCOP2D[4]=Pointer0[0];
 regCOP2D[5]=Pointer0[1];

 RTPT(&regg);

 Pointer0=GetAdressR(regSP);
 regT0=Pointer0[0x38>>2];

 if (regCOP2C[31]&0x7f87e000) regCOP2C[31]|=(1<<31); else regCOP2C[31]&=(1<<31);
 regT1=regCOP2C[31];

 Pointer1=GetAdressW(regT0);
 Pointer1[0]=regT1;

 NCLIP(&regg);

 regT0=Pointer0[0x10>>2];
 regT1=Pointer0[0x14>>2];
 regT2=Pointer0[0x18>>2];
 regV0=regCOP2D[24];


 Pointer1=GetAdressW(regA3);

 if (regV0>0) {}
 else { regCOP2D[0]=Pointer1[0]; rPC=regRA; return(46); }

 regCOP2D[0]=Pointer1[0];
 regCOP2D[1]=Pointer1[1];

 Pointer1=GetAdressW(regT0);
 regCOP2D[2]=Pointer1[0];
 regCOP2D[3]=Pointer1[1];

 Pointer1=GetAdressW(regT1);
 regCOP2D[4]=Pointer1[0];
 regCOP2D[5]=Pointer1[1];

 Pointer1=GetAdressW(regT2);
 regCOP2D[6]=Pointer1[0];

 NCCT(&regg);

 regT0=Pointer0[0x1c>>2];
 regT1=Pointer0[0x20>>2];
 regT2=Pointer0[0x24>>2];
 regT3=Pointer0[0x28>>2];
 regT4=Pointer0[0x2c>>2];
 regT5=Pointer0[0x30>>2];

 Pointer1=GetAdressW(regT0);
 Pointer1[0]=regCOP2D[12];

 Pointer1=GetAdressW(regT1);
 Pointer1[0]=regCOP2D[13];

 Pointer1=GetAdressW(regT2);
 Pointer1[0]=regCOP2D[14];

 Pointer1=GetAdressW(regT3);
 Pointer1[0]=regCOP2D[20];

 Pointer1=GetAdressW(regT4);
 Pointer1[0]=regCOP2D[21];

 Pointer1=GetAdressW(regT5);
 Pointer1[0]=regCOP2D[22];

 AVSZ3(&regg);

 regT1=Pointer0[0x34>>2];
 regT0=regCOP2D[7];

 Pointer1=GetAdressW(regT1);
 Pointer1[0]=regT0;

 rPC=regRA;
 return(96);
}

int HLE_0006(void)
{
 unsigned long *Pointer0;
 unsigned long *Pointer1;

 Pointer0=GetAdressR(regA0);
 regCOP2D[0]=Pointer0[0];
 regCOP2D[1]=Pointer0[1];
 Pointer0=GetAdressR(regA1);
 regCOP2D[2]=Pointer0[0];
 regCOP2D[3]=Pointer0[1];
 Pointer0=GetAdressR(regA2);
 regCOP2D[4]=Pointer0[0];
 regCOP2D[5]=Pointer0[1];

 RTPT(&regg);

 Pointer0=GetAdressR(regSP);
 regT0=Pointer0[0x10>>2];
 regT1=Pointer0[0x14>>2];
 regT2=Pointer0[0x18>>2];

 Pointer1=GetAdressW(regT0);
 Pointer1[0]=regCOP2D[12];
 Pointer1=GetAdressW(regT1);
 Pointer1[0]=regCOP2D[13];
 Pointer1=GetAdressW(regT2);
 Pointer1[0]=regCOP2D[14];

 if (regCOP2C[31]&0x7f87e000) regCOP2C[31]|=(1<<31); else regCOP2C[31]&=(1<<31);
 regV1=regCOP2C[31];

 Pointer1=GetAdressR(regA3);
 regCOP2D[0]=Pointer1[0];
 regCOP2D[1]=Pointer1[1];

 RTPS(&regg);

 regT0=Pointer0[0x1c>>2];
 regT1=Pointer0[0x20>>2];
 regT2=Pointer0[0x24>>2];

 Pointer1=GetAdressW(regT0);
 Pointer1[0]=regCOP2D[14];
 Pointer1=GetAdressW(regT1);
 Pointer1[0]=regCOP2D[8];

 if (regCOP2C[31]&0x7f87e000) regCOP2C[31]|=(1<<31); else regCOP2C[31]&=(1<<31);
 regT0=regCOP2C[31];

 regV0=regCOP2D[19];

 regT0=regT0|regV1;

 Pointer1=GetAdressW(regT2);
 Pointer1[0]=regT0;

 regV0=(signed long)regV0>>2;

 rPC=regRA;
 return(60);
}

int HLE_0007(void)
{
 register unsigned char *Pointer0;
 Pointer0=GetAdressW(regA0+7);
 if (regA1==0) Pointer0[0]=regV0=Pointer0[0]&0x00fd;
 else Pointer0[0]=regV0=Pointer0[0]|0x0002;
 rPC=regRA;
 return(16);
}

int HLE_0008(void)
{
 unsigned long *Pointer0;
 unsigned short *Pointer1;


 Pointer0=GetAdressR(regA0);

 regCOP2C[0]=Pointer0[0];
 regCOP2C[1]=Pointer0[1];
 regCOP2C[2]=Pointer0[2];
 regCOP2C[3]=Pointer0[3];
 regCOP2C[4]=Pointer0[4];

 Pointer1=GetAdressR(regA1);
 Pointer0=GetAdressR(regA1);

 regCOP2D[0]=(Pointer0[0]&0xffff)|(Pointer0[1]&0xFFFF0000);
 regCOP2D[1]=Pointer0[3];
 rtv0(&regg);
 regT3=regCOP2D[9]&0xffff;
 regT4=regCOP2D[10]<<16;
 regT5=regCOP2D[11]&0xffff;

 regCOP2D[0]=(Pointer0[0]>>16)|(Pointer0[2]<<16);
 regCOP2D[1]=(signed short)Pointer1[0xe>>1];
 rtv0(&regg);
 regT6=(regCOP2D[9]<<16)|regT3;
 regT7=regCOP2D[10];
 regT8=(regCOP2D[11]<<16)|regT5;;

 regCOP2D[0]=(Pointer0[1]&0xffff)|(Pointer0[2]&0xFFFF0000);
 regCOP2D[1]=Pointer0[4];
 rtv0(&regg);

 Pointer0=GetAdressW(regA2);
 Pointer0[0]=regT6;
 Pointer0[0xc>>2]=regT8;

 Pointer0[0x4>>2]=(regCOP2D[9]&0xffff)|regT4;
 Pointer0[0x8>>2]=(regCOP2D[10]<<16)|(regT7&0xffff);
 Pointer0[0x10>>2]=regCOP2D[11];

 regV0=regA2;
 rPC=regRA;
 return(134);
}

int HLE_0009(void)
{
 register unsigned long *Pointer0;

 Pointer0=GetAdressR(regA0);
 regCOP2C[16]=Pointer0[0];
 regCOP2C[17]=Pointer0[1];
 regCOP2C[18]=Pointer0[2];
 regCOP2C[19]=Pointer0[3];
 regCOP2C[20]=Pointer0[4];
 rPC=regRA;
 return(24);
}

int HLE_0010(void)
{
 register unsigned long *Pointer0;

 Pointer0=GetAdressR(regA0);
 regCOP2C[5]=Pointer0[5];
 regCOP2C[6]=Pointer0[6];
 regCOP2C[7]=Pointer0[7];
 rPC=regRA;
 return(16);
}

int HLE_0011(void)
{
 regCOP2C[13]=regA0<<4;
 regCOP2C[14]=regA1<<4;
 regCOP2C[15]=regA2<<4;
 rPC=regRA;
 return(16);
}

int HLE_0012(void)
{
 WCD[0](0x00);
 WCD[3](0x80);

 regA2=0x2000|0x943;

 ((unsigned long*)psxH)[0x10f0>>2]|=0x8000;

 ((unsigned long*)psxH)[0x10b0>>2]=regA0;

 ((unsigned long*)psxH)[0x10b4>>2]=regA1|0x10000;

repi:
 regV0=RCD[0]()&0x40;
 if (regV0==0) {
  return(1600);
  goto repi;
  }

 regV0=0x11000000;
 doDMA[3](0x11000000);

 ((unsigned long*)psxH)[0x1020>>2]=0x1325;

 regV0=0;
 rPC=regRA;
 return(120);
}

int HLE_0013(void)
{

 unsigned long *Pointer0;

 if (regA1&0x5f800000) { rPC=regRA; return(470); }

 Pointer0=GetAdressR(regA0);

 if ((((Pointer0[1]&0xffff)*(Pointer0[1]>>16))>>1)==0) { rPC=regRA; return(470); }

 if ((((Pointer0[0]&0xffff)*(Pointer0[0]>>16))>>1) > 9999999) { rPC=regRA; return(470); }

 GPU__writeStatus(0x04000000);
 GPU__writeData(0x01000000);
 GPU__writeData(0xa0000000);
 GPU__writeData(Pointer0[0]);
 GPU__writeData(Pointer0[1]);
 GPU__writeStatus(0x04000002);

 {
  unsigned long size, *madr;
  madr=(void*)psxM+(regA1&0x1fffff);
  size=((Pointer0[1]&0xffff)*(Pointer0[1]>>16))>>1;
  if (NEWGPU) GPU__writeDataMem(madr,size);
  else while (size>0) { GPU__writeData(*madr); size--; madr++; }
 }

 GPU__writeStatus(0x04000000);

 rPC=regRA;
 return(470);
}

int HLE_0014(void)
{
 regV0=0;
 rPC=regRA;
 return(100);
}

int HLE_0015(void)
{
 unsigned long *Pointer0;
 unsigned long *Pointer1;

 Pointer0=GetAdressR(regA0);
 regCOP2C[0]=Pointer0[0];
 regCOP2C[1]=Pointer0[1];
 regCOP2C[2]=Pointer0[2];
 regCOP2C[3]=Pointer0[3];
 regCOP2C[4]=Pointer0[4];

 Pointer0=GetAdressR(regA1);
 regCOP2D[0]=(Pointer0[0]&0xffff)|(Pointer0[1]&0xffff0000);
 regCOP2D[1]=Pointer0[3];
 rtv0(&regg);
 regT3=regCOP2D[9]&0xffff;
 regT4=regCOP2D[10];
 regT5=regCOP2D[11];

 regCOP2D[0]=(Pointer0[0]>>16)|(Pointer0[2]<<16);
 regCOP2D[1]=(signed short)(Pointer0[3]>>16);
 rtv0(&regg);
 regT6=(regCOP2D[9]<<16)|regT3;
 regT7=regCOP2D[10]&0xffff;
 regT8=regCOP2D[11]<<16;

 regCOP2D[0]=(Pointer0[1]&0xffff)|(Pointer0[2]&0xffff0000);
 regCOP2D[1]=Pointer0[4];
 rtv0(&regg);
 Pointer1=GetAdressW(regA2);
 Pointer1[0]=regT6;
 Pointer1[3]=regT8|(regT5&0xffff);

 Pointer1[4]=regCOP2D[11];
 Pointer1[1]=(regCOP2D[9]&0xffff)|(regT4<<16);
 Pointer1[2]=(regCOP2D[10]<<16)|regT7;


 regCOP2D[0]=(Pointer0[5]&0xffff)|(Pointer0[6]<<16);
 regCOP2D[1]=Pointer0[7];
 rtv0(&regg);

 Pointer0=GetAdressR(regA0);

 Pointer1[5]=regCOP2D[25]+Pointer0[5];
 Pointer1[6]=regCOP2D[26]+Pointer0[6];
 Pointer1[7]=regCOP2D[27]+Pointer0[7];

 regV0=regA2;
 rPC=regRA;
 return(176);
}

int HLE_0016(void)
{
 unsigned long *Pointer0;

 Pointer0=GetAdressR(regA0);
 regCOP2D[0]=Pointer0[0];
 regCOP2D[1]=Pointer0[1];
 rtv0(&regg);
 Pointer0=GetAdressW(regA1);
 Pointer0[0]=regCOP2D[9];
 Pointer0[1]=regCOP2D[10];
 Pointer0[2]=regCOP2D[11];
 regV0=regA2;
 rPC=regRA;

 return(24);

}

int HLE_0017(void)
{
 register unsigned long *Pointer0, *Pointer1;

 Pointer0=GetAdressW(regA0);
 Pointer1=GetAdressW(regA1);
 Pointer1[0]=(Pointer1[0]&0xff000000)|(Pointer0[0]&0x00ffffff);
 Pointer0[0]=(Pointer0[0]&0xff000000)|(regA1&0x00ffffff);
 rPC=regRA;

 return(30);
}

int HLE_0018(void)
{
 register unsigned long *Pointer0, *Pointer1;

 Pointer0=GetAdressW(regA0);
 Pointer1=GetAdressW(regA2);
 Pointer1[0]=(Pointer1[0]&0xff000000)|(Pointer0[0]&0x00ffffff);
 Pointer0[0]=(Pointer0[0]&0xff000000)|(regA1&0x00ffffff);
 rPC=regRA;

 return(30);
}

int HLE_0019(void)
{

 unsigned long *Pointer0;
 unsigned long ii;

 if (regA1&0x5f800000) { rPC=regRA; return(470); }

 Pointer0=GetAdressR(regA0);

 if ((((Pointer0[1]&0xffff)*(Pointer0[1]>>16))>>1)==0) { rPC=regRA; return(470); }

 ii= (signed short)regA1 | ((signed short)regA1<<16);

 GPU__writeStatus(0x04000000);
 GPU__writeData(0x80000000);
 GPU__writeData(Pointer0[0]);
 GPU__writeData(ii);
 GPU__writeData(Pointer0[1]);
 GPU__writeStatus(0x04000000);

 rPC=regRA;
 return(470);
}

unsigned long H[256];
int HLE_0020(void)
{
 register unsigned long *HCount;
 register unsigned long *VCount;
 unsigned long Begad = rPC&0x1ffffc;

   if (regA0 > 0x7fffffff)
    {
     VCount=GetAdressR((psxML[(Begad>>2)+16]<<16) + (signed short)(psxML[(Begad>>2)+17]&0xffff) );
     regV0=VCount[0];
     rPC=regRA;
     return(80);
    }

 if (H[2]==0)
  {
   if (regA0 == 1)
    {
     HCount=GetAdressR((psxML[(Begad>>2)+2]<<16) + (signed short)(psxML[(Begad+4)>>2]&0xffff) + 8);
     regV0=((unsigned long)temporizer-HCount[0])&0xffff;
     rPC=regRA;
     return(96);
    }
   else
    {
     HCount=GetAdressR((psxML[(Begad>>2)+2]<<16) + (signed short)(psxML[(Begad+4)>>2]&0xffff) + 8);
     H[4]=((unsigned long)temporizer-HCount[0])&0xffff;
     H[2]=H[3]+regA0;
     if (regA0==0) H[2]+=1;
     if (H[2]<VsyncCount) H[2]=VsyncCount+1;
     rPC=Begad;
     return(1600);
    }
  }
 else
  {
   unsigned long i=0;
   if (H[2]<=VsyncCount)
    {
     HCount=GetAdressW((psxML[(Begad>>2)+2]<<16) + (signed short)(psxML[(Begad+4)>>2]&0xffff) + 8);
     HCount[0]=temporizer;
     H[2]=0; H[3]=VsyncCount; regV0=H[4];
     rPC=regRA;
     return(48);
    }

   if ((regCOP0[12] & 0x401)!=0x401)
    {
       regV0=((int *)psxM)[(Begad>>2)+2]<<16;
       rPC=Begad+4;
       return(4);

     HCount=GetAdressW((psxML[(Begad>>2)+2]<<16) + (signed short)(psxML[(Begad+4)>>2]&0xffff) + 8);
     HCount[0]=temporizer;
     i=tempohsync+(((H[2]-VsyncCount)-1)*312);
     temporizer+=i;
     psxHL[0x1100>>2]+=1600*i;
     H[2]=0; H[3]=VsyncCount; regV0=H[4];
     rPC=regRA;
     return(1600);
    }

   if (psxHL[0x1070>>2]&psxHL[0x1074>>2]) hardInterrupt=1;
   if  (hardInterrupt)
    {
     hardDMA=0xffffffff;
     hardInterrupt=0; rPC=Begad;
     return(IntHand());
    }

     i=tempohsync-temporizer;
     if ( i > (cdV-temporizer) ) i=cdV-temporizer;
     if ( i > (NextRTC0-temporizer) ) i=NextRTC0-temporizer;
     if ( i > (NextRTC1-temporizer) ) i=NextRTC1-temporizer;
     if ( i > (NextRTC2-temporizer) ) i=NextRTC2-temporizer;

     if (i==0) i=1;
     temporizer+= (i-1);
     psxHL[0x1100>>2]+=1600*(i-1);
     rPC=Begad;
     return(1600);
  }
}

int HLE_0021(void)
{
 register unsigned long *HCount;
 register unsigned long *VCount;
 unsigned long Begad = rPC&0x1ffffc;

   if (regA0 > 0x7fffffff)
    {
     VCount=GetAdressR((psxML[(Begad>>2)+24]<<16) + (signed short)(psxML[(Begad>>2)+25]&0xffff) );
     regV0=VCount[0];
     rPC=regRA;
     return(80);
    }

 if (H[2]==0)
  {
   if (regA0 == 1)
    {
     HCount=GetAdressR((psxML[(Begad>>2)+2]<<16) + (signed short)(psxML[(Begad+4)>>2]&0xffff) + 8);
     regV0=((unsigned long)temporizer-HCount[0])&0xffff;
     rPC=regRA;
     return(96);
    }
   else
    {
     HCount=GetAdressR((psxML[(Begad>>2)+2]<<16) + (signed short)(psxML[(Begad+4)>>2]&0xffff) + 8);
     H[4]=((unsigned long)temporizer-HCount[0])&0xffff;
     H[2]=H[3]+regA0;
     if (regA0==0) H[2]+=1;
     if (H[2]<VsyncCount) H[2]=VsyncCount+1;
     rPC=Begad;
     return(1600);
    }
  }
 else
  {
   unsigned long i=0;
   if (H[2]<=VsyncCount)
    {
     HCount=GetAdressR((psxML[(Begad>>2)+2]<<16) + (signed short)(psxML[(Begad+4)>>2]&0xffff) + 8);
     HCount[0]=temporizer;
     H[2]=0; H[3]=VsyncCount; regV0=H[4];
     rPC=regRA;
     return(48);
    }

   if ((regCOP0[12] & 0x401)!=0x401)
    {

       regV0=((int *)psxM)[(Begad>>2)+2]<<16;
       rPC=Begad+4;
       return(4);


     HCount=GetAdressR((psxML[(Begad>>2)+2]<<16) + (signed short)(psxML[(Begad+4)>>2]&0xffff) + 8);
     HCount[0]=temporizer;
     i=tempohsync+(((H[2]-VsyncCount)-1)*312);
     temporizer+=i;
     psxHL[0x1100>>2]+=1600*i;
     H[2]=0; H[3]=VsyncCount; regV0=H[4];
     rPC=regRA;
     return(1600);
    }

   if (psxHL[0x1070>>2]&psxHL[0x1074>>2]) hardInterrupt=1;
   if  (hardInterrupt)
    {
     hardDMA=0xffffffff;
     hardInterrupt=0; rPC=Begad;
     return(IntHand());
    }

     i=tempohsync-temporizer;
     if ( i > (cdV-temporizer) ) i=cdV-temporizer;
     if ( i > (NextRTC0-temporizer) ) i=NextRTC0-temporizer;
     if ( i > (NextRTC1-temporizer) ) i=NextRTC1-temporizer;
     if ( i > (NextRTC2-temporizer) ) i=NextRTC2-temporizer;

     if (i==0) i=1;
     temporizer+= (i-1);
     psxHL[0x1100>>2]+=1600*(i-1);
     rPC=Begad;
     return(1600);
  }
}

int HLE_0022(void)
{

 unsigned long *Pointer0;

 Pointer0=GetAdressR(regA0);

 if ((((Pointer0[1]&0xffff)*(Pointer0[1]>>16))>>1)==0) { rPC=regRA; return(470); }

 GPU__writeStatus(0x04000000);
 GPU__writeData(0x02000000);
 GPU__writeData(Pointer0[0]);
 GPU__writeData(Pointer0[1]);
 GPU__writeStatus(0x04000000);

 rPC=regRA;
 return(470);
}

int HLE_0023(void)
{
 register int i;

 regA0&=0x1fffff;
 for (i=0; i<regA1; i++)
   psxML[(regA0>>2)+i]=((regA0+(i*4))+4)&0x1fffff;
 psxML[(regA0>>2)+regA1-1]=0x00ffffff;
 rPC=regRA;
 return(100+(regA1*20));
}

int HLE_0024(void)
{
 double tt;

 tt=(double)regA0;
 tt=sqrt(tt);
 regV0=(unsigned long)floor(tt);
 rPC=regRA;
 return(68);
}

int HLE_0025(void)
{
 double tt;

 tt=(double)regA0;
 tt=sqrt(tt/(double)4096);
 regV0=(unsigned long)floor(tt*(double)4096);
 rPC=regRA;
 return(76);
}

int HLE_0026(void)
{
 register unsigned long *Pointer0;
 unsigned long a,b,c;

 a=regCOP2C[0];
 b=regCOP2C[2];
 c=regCOP2C[4];
 Pointer0=GetAdressR(regA0);
 regCOP2C[0]=Pointer0[0];
 regCOP2C[2]=Pointer0[1];
 regCOP2C[4]=Pointer0[2];
 Pointer0=GetAdressR(regA1);
 regCOP2D[9]=Pointer0[0];
 regCOP2D[10]=Pointer0[1];
 regCOP2D[11]=Pointer0[2];
 op12(&regg);
 Pointer0=GetAdressW(regA2);
 Pointer0[0]=regCOP2D[25];
 Pointer0[1]=regCOP2D[26];
 Pointer0[2]=regCOP2D[27];
 regCOP2C[0]=a;
 regCOP2C[2]=b;
 regCOP2C[4]=c;
 rPC=regRA;
 return(46);
}

int HLE_0027(void)
{
 register unsigned char *Pointer0, *Pointer1;
 unsigned long Counter;

 if (regA0==0) { regV0=0; rPC=regRA; return(8); }
 if ((signed long)regA2<=0) { regV1=regA0; regV0=regV1; rPC=regRA; return(12); }

 Pointer0=GetAdressW(regA0);
 Pointer1=GetAdressR(regA1);

 Counter=14;

 salta:
 Pointer0[0]=(unsigned char)Pointer1[0];
 Pointer1++; Pointer0++;
 regA2--;
 Counter+=12;
 if ((signed long)regA2>0) goto salta;

 regV1=regA0;
 regV0=regA0;
 rPC=regRA;
 return(Counter);
}

int HLE_0028(void)
{
 register unsigned char *Pointer0;
 Pointer0=GetAdressW(regA0+7);
 if (regA1==0) Pointer0[0]=regV0=Pointer0[0]&0x00fe;
 else Pointer0[0]=regV0=Pointer0[0]|0x0001;
 rPC=regRA;
 return(16);
}

int HLE_0029(void)
{
 register unsigned short *Pointer0;
 register unsigned long *Pointer1;

 Pointer1=GetAdressW(regSP+0x10);
 regV1=Pointer1[0];
 regV0=regA0;

 Pointer0=GetAdressW(regV0);
 Pointer1=GetAdressW(regV0);

 Pointer0[0]=regA1;
 Pointer0[1]=regA2;
 Pointer0[2]=regA3;
 Pointer0[3]=regV1;
 Pointer1[2]=0;
 Pointer1[3]=0;
 Pointer1[4]=0;
 rPC=regRA;
 return(32);
}

int HLE_0029b(void)
{
 register unsigned long *Pointer0,*Pointer1;

 Pointer0=GetAdressW(regA0);
 Pointer1=GetAdressW(regA1);

 regT3=Pointer1[0];
 regT4=Pointer1[1];
 regT5=Pointer1[2];
 regT0=Pointer0[0];

 regT1=(signed short)regT0;
 regT1=(unsigned long)regT1 * (unsigned long)regT3;

 regT1=((signed long)regT1>>0x0c)&0xffff;
 regT2=(signed long)regT0>>16;
 regT2=(unsigned long)regT2 * (unsigned long)regT4;

 Pointer0[0]=regT1|(((signed long)regT2>>0x0c)<<16);

 regT0=Pointer0[1];

 regT1=(signed short)regT0;
 regT1=(unsigned long)regT1 * (unsigned long)regT5;

 regT1=((signed long)regT1>>0x0c)&0xffff;
 regT2=(signed long)regT0>>16;
 regT2=(unsigned long)regT2 * (unsigned long)regT3;

 Pointer0[1]=regT1|(((signed long)regT2>>0x0c)<<16);

 regT0=Pointer0[2];

 regT1=(signed short)regT0;
 regT1=(unsigned long)regT1 * (unsigned long)regT4;

 regT1=((signed long)regT1>>0x0c)&0xffff;
 regT2=(signed long)regT0>>16;
 regT2=(unsigned long)regT2 * (unsigned long)regT5;

 Pointer0[2]=regT1|(((signed long)regT2>>0x0c)<<16);

 regT0=Pointer0[3];

 regT1=(signed short)regT0;
 regT1=(unsigned long)regT1 * (unsigned long)regT3;

 regT1=((signed long)regT1>>0x0c)&0xffff;
 regT2=(signed long)regT0>>16;
 regT2=(unsigned long)regT2 * (unsigned long)regT4;

 Pointer0[3]=regT1|(((signed long)regT2>>0x0c)<<16);

 regT0=Pointer0[4];

 regT1=(signed short)regT0;
 regT1=(unsigned long)regT1 * (unsigned long)regT5;
 Pointer0[4]=(signed long)regT1>>0x0c;

 rPC=regRA;
 regV0=regA0;

 return(160);
}

int HLE_0029c(void)
{
 register signed short *Pointer0;
 register unsigned short *Pointer1;

 Pointer0=GetAdressW(regA0);
 Pointer1=GetAdressW(regA1);

 regT7=Pointer0[0];
 regV0=regA1;
 regT9=(unsigned short)regT7;

 if ((signed long)regT7<0)
  {
   regT9=sincos[(0-regT7)&0xfff];
   regT8=(signed short)regT9;
   regT3=0-regT8;
   regT0=(signed long)regT9>>16;
  }
 else
  {
   regT9=sincos[regT9];
   regT3=(signed short)regT9;
   regT0=(signed long)regT9>>16;
  }

 regT7=Pointer0[1];
 regT9=regT7&0x0fff;

 if ((signed long)regT7<0)
  {
   regT9=sincos[((0-regT7)&0xfff)];
   regT4=(signed short)regT9;
   regT6=0-regT4;
   regT1=(signed long)regT9>>16;
  }
 else
  {
   regT9=sincos[regT9];
   regT6=(signed short)regT9;
   regT4=0-regT6;
   regT1=(signed long)regT9>>16;
  }

 regT8=(unsigned long)regT1 * (unsigned long)regT3;
 regT7=Pointer0[2];
 Pointer1[2]=regT6;
 regT9=0-regT8;
 regT6=(signed long)regT9>>0x0c;
 regLO=(unsigned long)regT1 * (unsigned long)regT0;
 Pointer1[5]=regT6;
 regT9=regT7&0x0fff;

 if ((signed long)regT7<0)
  {
   Pointer1[8]=(signed long)regLO>>0x0c;
   regT7=0-regT7;
   regT7=regT7&0x0fff;
   regT8=regT7<<0x02;
   regT9=sincos[regT8>>2];
   regT8=(signed short)regT9;
   regT5=0-regT8;
   regT2=(signed long)regT9>>16;
  }
 else
  {
   Pointer1[8]=(signed long)regLO>>0x0c;
   regT8=regT9<<0x02;
   regT9=sincos[regT8>>2];
   regT5=(signed short)regT9;
   regT2=(signed long)regT9>>16;
  }

 regT7=(unsigned long)regT2 * (unsigned long)regT1;
 Pointer1[0]=(signed long)regT7>>0x0c;
 regT7=(unsigned long)regT5*(unsigned long)regT1;
 regT6=0-regT7;
 regT7=(signed long)regT6>>0x0c;
 regLO=(unsigned long)regT2*(unsigned long)regT4;
 Pointer1[1]=regT7;
 regT8=(signed long)regLO>>0x0c;
 regT7=(unsigned long)regT8*(unsigned long)regT3;
 regT6=(signed long)regT7>>0x0c;
 regT7=(unsigned long)regT5*(unsigned long)regT0;
 regT9=(signed long)regT7>>0x0c;
 regT7=regT9-regT6;
 regT6=(unsigned long)regT8*(unsigned long)regT0;
 Pointer1[3]=regT7;
 regT7=(signed long)regT6>>0x0c;
 regT6=(unsigned long)regT5*(unsigned long)regT3;
 regT9=(signed long)regT6>>0x0c;
 regT6=regT9+regT7;
 regT7=(unsigned long)regT5*(unsigned long)regT4;
 Pointer1[6]=regT6;
 regT8=(signed long)regT7>>0x0c;
 regT7=(unsigned long)regT8*(unsigned long)regT3;
 regT6=(signed long)regT7>>0x0c;
 regT7=(unsigned long)regT2*(unsigned long)regT0;
 regT9=(signed long)regT7>>0x0c;
 regT7=regT9+regT6;
 regT6=(unsigned long)regT8*(unsigned long)regT0;
 Pointer1[4]=regT7;
 regT7=(signed long)regT6>>0x0c;
             
 regT6=(unsigned long)regT2*(unsigned long)regT3;
 regT9=(signed long)regT6>>0x0c;
 regT6=regT9-regT7;
 Pointer1[7]=regT6;
 rPC=regRA;

 return(340);
}

int HLE_0030(void)
{
 register int *Pointer0;

 Pointer0= GetAdressR(regA0);
 regCOP2C[8]= Pointer0[0];
 regCOP2C[9]= Pointer0[1];
 regCOP2C[10]= Pointer0[2];
 regCOP2C[11]= Pointer0[3];
 regCOP2C[12]= Pointer0[4];
 rPC=regRA;
 return(26);
}

int HLE_0031(void)
{
 register int *Pointer0;

 Pointer0= GetAdressR(regA0);
 regCOP2D[0]=Pointer0[0];
 regCOP2D[1]=Pointer0[1];
 RTPS(&regg);
 Pointer0= GetAdressW(regA1);
 Pointer0[0]=regCOP2D[14];
 Pointer0= GetAdressW(regA2);
 Pointer0[0]=regCOP2D[8];
 if (regCOP2C[31]&0x7f87e000) regCOP2C[31]|=(1<<31);
 else regCOP2C[31]&=(1<<31);
 Pointer0= GetAdressW(regA3);
 Pointer0[0]=regCOP2C[31];
 regV0=(signed long)regCOP2D[19]>>2;
 rPC=regRA;
 return(24);
}

int HLE_0032(void)
{
 register unsigned long *Pointer0;
 register unsigned short *Pointer1;

 Pointer0= GetAdressR(regA0);
 regCOP2C[0]= Pointer0[0];
 regCOP2C[1]= Pointer0[1];
 regCOP2C[2]= Pointer0[2];
 regCOP2C[3]= Pointer0[3];
 regCOP2C[4]= Pointer0[4];

 Pointer0= GetAdressR(regA1);
 regCOP2D[0]= Pointer0[0];
 regCOP2D[1]= Pointer0[1];

 rtv0(&regg);

 Pointer1= GetAdressW(regA2);
 Pointer1[0]=regCOP2D[9];
 Pointer1[1]=regCOP2D[10];
 Pointer1[2]=regCOP2D[11];
 regV0=regA2;
 rPC=regRA;
 return(48);
}

int HLE_0033(void)
{
 register unsigned long *Pointer0;

 Pointer0= GetAdressR(regA0);
 regCOP2C[0]=Pointer0[0];
 regCOP2C[1]=Pointer0[1];
 regCOP2C[2]=Pointer0[2];
 regCOP2C[3]=Pointer0[3];
 regCOP2C[4]=Pointer0[4];
 Pointer0= GetAdressR(regA1);
 regT0=Pointer0[0];
 regT1=Pointer0[1];
 regT2=Pointer0[2];

 if ((signed long)regT0 < 0)
  {
   regT0=-regT0;
   regT3=-((signed long)regT0>>15);
   regT0=-(regT0&0x7fff);
  }
 else
  {
   regT3=(signed long)regT0>>15;
   regT0=regT0&0x7fff;
  }

 if ((signed long)regT1 < 0)
  {
   regT1=-regT1;
   regT4=-((signed long)regT1>>15);
   regT1=-(regT1&0x7fff);
  }
 else
  {
   regT4=(signed long)regT1>>15;
   regT1=regT1&0x7fff;
  }

 if ((signed long)regT2 < 0)
  {
   regT2=-regT2;
   regT5=-((signed long)regT2>>15);
   regT2=-(regT2&0x7fff);
  }
 else
  {
   regT5=(signed long)regT2>>15;
   regT2=regT2&0x7fff;
  }

  regCOP2D[9]=regT3;
  regCOP2D[10]=regT4;
  regCOP2D[11]=regT5;
  rtir0(&regg);
  regT3=regCOP2D[25];
  regT4=regCOP2D[26];
  regT5=regCOP2D[27];

  regCOP2D[9]=regT0;
  regCOP2D[10]=regT1;
  regCOP2D[11]=regT2;
  rtir(&regg);

  if ((signed long)regT3 < 0) regT3=-((-regT3)<<3);
  else regT3=regT3<<3;

  if ((signed long)regT4 < 0) regT4=-((-regT4)<<3);
  else regT4=regT4<<3;

  if ((signed long)regT5 < 0) regT5=-((-regT5)<<3);
  else regT5=regT5<<3;

  regT0=regCOP2D[25]+regT3;
  regT1=regCOP2D[26]+regT4;
  regT2=regCOP2D[27]+regT5;

  Pointer0= GetAdressW(regA2);
  Pointer0[0]=regT0;
  Pointer0[1]=regT1;
  Pointer0[2]=regT2;

  regV0=regA2;
  rPC=regRA;
  return(170);
}

int HLE_0034(void)
{
 register unsigned char *Pointer0;

 Pointer0= GetAdressW(regA0);
 Pointer0[3]=0x04;
 regV0=Pointer0[7]=0x20;
 rPC=regRA;
 return(10);
}

int HLE_0035(void)
{
 register unsigned char *Pointer0;

 Pointer0= GetAdressW(regA0);
 Pointer0[3]=0x07;
 regV0=Pointer0[7]=0x24;
 rPC=regRA;
 return(10);
}

int HLE_0036(void)
{
 register unsigned char *Pointer0;

 Pointer0= GetAdressW(regA0);
 Pointer0[3]=0x06;
 regV0=Pointer0[7]=0x30;
 rPC=regRA;
 return(10);
}

int HLE_0037(void)
{
 register unsigned char *Pointer0;

 Pointer0= GetAdressW(regA0);
 Pointer0[3]=0x09;
 regV0=Pointer0[7]=0x34;
 rPC=regRA;
 return(10);
}

int HLE_0038(void)
{
 register unsigned char *Pointer0;

 Pointer0= GetAdressW(regA0);
 Pointer0[3]=0x05;
 regV0=Pointer0[7]=0x28;
 rPC=regRA;
 return(10);
}

int HLE_0039(void)
{
 register unsigned char *Pointer0;

 Pointer0= GetAdressW(regA0);
 Pointer0[3]=0x09;
 regV0=Pointer0[7]=0x2c;
 rPC=regRA;
 return(10);
}

int HLE_0040(void)
{
 regSP+=0xFFFFFFC8;
 rPC+=4;
 return(4);
}

int HLE_0041(void)
{
 register int *Pointer0;

 Pointer0= GetAdressR(regA0);
 regCOP2C[0]= Pointer0[0];
 regCOP2C[1]= Pointer0[1];
 regCOP2C[2]= Pointer0[2];
 regCOP2C[3]= Pointer0[3];
 regCOP2C[4]= Pointer0[4];
 rPC=regRA;
 return(26);
}

int HLE_0042(void)
{
 register unsigned long *Pointer0, *Pointer1;

 Pointer0= GetAdressW(regA0);
 Pointer1= GetAdressR(regA1);

 regT0=Pointer0[0];
 regT3=Pointer1[0];
 regT1=(signed short)regT0;

 regT1=((unsigned long long)regT1*(unsigned long long)regT3) & 0xffffffff;
 regT1=((signed long)regT1>>12)&0xffff;
 regT4=Pointer1[1];
 regT2=(signed long)regT0>>16;
 regT5=Pointer1[2];
 regT0=Pointer0[1];
 regV0=regA0;

 regT2=((unsigned long long)regT2*(unsigned long long)regT4) & 0xffffffff;
 Pointer0[0]=regT1 | (((signed long)regT2>>12)<<16);
 regT1=(signed short)regT0;

 regT1=((unsigned long long)regT1*(unsigned long long)regT5) & 0xffffffff;
 regT1=((signed long)regT1>>12)&0xffff;
 regT2=(signed long)regT0>>16;
 regT0=Pointer0[2];

 regT2=((unsigned long long)regT2*(unsigned long long)regT3) & 0xffffffff;
 regT1=regT1|(((signed long)regT2>>12)<<16);
 Pointer0[1]=regT1;
 regT1=(signed short)regT0;

 regT1=((unsigned long long)regT1*(unsigned long long)regT4) & 0xffffffff;
 regT1=((signed long)regT1>>12)&0xffff;
 regT2=(signed long)regT0>>16;
 regT0=Pointer0[3];

 regT2=((unsigned long long)regT2*(unsigned long long)regT5) & 0xffffffff;
 regT1=regT1|(((signed long)regT2>>12)<<16);
 Pointer0[2]=regT1;
 regT1=(signed short)regT0;

 regT1=((unsigned long long)regT1*(unsigned long long)regT3) & 0xffffffff;
 regT1=((signed long)regT1>>12)&0xffff;
 regT2=(signed long)regT0>>16;
 regT0=Pointer0[4];

 regT2=((unsigned long long)regT2*(unsigned long long)regT4) & 0xffffffff;
 regT1=regT1|(((signed long)regT2>>12)<<16);
 Pointer0[3]=regT1;
 regT1=(signed short)regT0;

 regT1=((unsigned long long)regT1*(unsigned long long)regT5) & 0xffffffff;
 regT1=(signed long)regT1>>12;
 Pointer0[4]=regT1;

 rPC=regRA;
 return(148);
}

int HLE_0043(void)
{
 register unsigned long *Pointer0, *Pointer1;

 Pointer0= GetAdressR(regA0);
 Pointer1= GetAdressW(regA1);

 regT0=Pointer0[0];
 regT1=Pointer0[1];
 regT2=Pointer0[2];

 if ((signed long)regT0<0)
  {
   regT0=0-regT0;
   regT3=(signed long)regT0>>15;
   regT3=0-regT3;
   regT0&=0x7fff;
   regT0=0-regT0;
  }
 else
  {
   regT3=(signed long)regT0>>15;
   regT0&=0x7fff;
  }

 if ((signed long)regT1<0)
  {
   regT1=0-regT1;
   regT4=(signed long)regT1>>15;
   regT4=0-regT4;
   regT1&=0x7fff;
   regT1=0-regT1;
  }
 else
  {
   regT4=(signed long)regT1>>15;
   regT1&=0x7fff;
  }

 if ((signed long)regT2<0)
  {
   regT2=0-regT2;
   regT5=(signed long)regT2>>15;
   regT5=0-regT5;
   regT2&=0x7fff;
   regT2=0-regT2;
  }
 else
  {
   regT5=(signed long)regT2>>15;
   regT2&=0x7fff;
  }

 regCOP2D[9]=regT3;
 regCOP2D[10]=regT4;
 regCOP2D[11]=regT5;
 rtir0(&regg);
 regT3=regCOP2D[25];
 regT4=regCOP2D[26];
 regT5=regCOP2D[27];

 regCOP2D[9]=regT0;
 regCOP2D[10]=regT1;
 regCOP2D[11]=regT2;
 rtir(&regg);

 if ((signed long)regT3<0)
  {
   regT3=0-regT3;
   regT3=regT3<<3;
   regT3=0-regT3;
  }
 else
  {
   regT3=regT3<<3;
  }

 if ((signed long)regT4<0)
  {
   regT4=0-regT4;
   regT4=regT4<<3;
   regT4=0-regT4;
  }
 else
  {
   regT4=regT4<<3;
  }

 if ((signed long)regT5<0)
  {
   regT5=0-regT5;
   regT5=regT5<<3;
   regT5=0-regT5;
  }
 else
  {
   regT5=regT5<<3;
  }

 Pointer1[0]=regCOP2D[25]+regT3;
 Pointer1[1]=regCOP2D[26]+regT4;
 Pointer1[2]=regCOP2D[27]+regT5;
 regV0=regA1;
 rPC=regRA;
 return(160);
}

int HLE_0044(void)
{

 if ( (cdV > temporizer) && (cdV != 0xffffffff) )
  {
   cdV-=((cdV-temporizer)/2)*1;
   regSP-=40;
   rPC=H[5]+4;
   return(1600);
  }

 regSP-=40;
 rPC=H[5]+4;
 return(4);

 regV0=0;
 rPC=regRA;
 return(100);
}

int HLE_0045(void)
{
 regV0=1;
 rPC=regRA;
 return(80);
}

int HLE_0046(void)
{
 register unsigned char *Pointer0, *Pointer1;
 regSP-=40;
 rPC=H[200]+4;
 return(2);
}

int HLE_0047(void)
{
 regSP-=40;
 rPC=H[201]+4;
 return(2);
}

int HLE_0048(void)
{
 unsigned long *Pointer0, *Pointer1;
 unsigned short *Pointer2;

 Pointer0= GetAdressR(regA0);
 Pointer1= GetAdressW(regA1);
 Pointer2= GetAdressW(regA1);

 regV0=regA1;
 Pointer1[0]=Pointer0[1];
 Pointer2[0]=Pointer0[0];
 Pointer1[1]=Pointer0[0];
 Pointer1[2]=Pointer0[3];
 Pointer2[2]=Pointer0[3];
 Pointer1[3]=Pointer0[2];
 Pointer2[4]=Pointer0[2];
 Pointer2[6]=Pointer0[1];
 Pointer2[8]=Pointer0[4];
 rPC=regRA;
 return(36);

}

int HLE_0049(void)
{
  register int *Pointer0;
  register unsigned short *Pointer1;

  Pointer0 = GetAdressR(regA0);
  regCOP2C[0]=Pointer0[0];
  regCOP2C[1]=Pointer0[1];
  regCOP2C[2]=Pointer0[2];
  regCOP2C[3]=Pointer0[3];
  regCOP2C[4]=Pointer0[4];

  Pointer1 = GetAdressR(regA1);
  regCOP2D[0] = Pointer1[0] | (Pointer1[3]<<16);
  regCOP2D[1] = Pointer1[6];

  rtv0(&regg);
  regT3 = regCOP2D[9] & 0xffff;
  regT4 = regCOP2D[10] << 16;
  regT5 = regCOP2D[11] & 0xffff;

  regCOP2D[0] = Pointer1[1] | (Pointer1[4]<<16);
  regCOP2D[1] = (signed short)Pointer1[7];

  rtv0(&regg);
  Pointer0[0] = (regCOP2D[9] << 16) | regT3;
  regT7 = regCOP2D[10] & 0xffff;
  Pointer0[3] = (regCOP2D[11] << 16) | regT5;

  regCOP2D[0] = Pointer1[2] | (Pointer1[5]<<16);
  regCOP2D[1] = Pointer1[8];

  rtv0(&regg);
  Pointer0[1] = (regCOP2D[9] & 0xffff) | regT4;
  Pointer0[2] = (regCOP2D[10] << 16) | regT7;
  Pointer0[4] = regCOP2D[11];

  regV0 = regA0;

  rPC = regRA;

  return(136);
}


int HLE_0050(void)
{
  register int *Pointer0;
  register unsigned short *Pointer1;

  Pointer0 = GetAdressR(regA0);
  regCOP2C[0]=Pointer0[0];
  regCOP2C[1]=Pointer0[1];
  regCOP2C[2]=Pointer0[2];
  regCOP2C[3]=Pointer0[3];
  regCOP2C[4]=Pointer0[4];

  Pointer1 = GetAdressR(regA1);
  regCOP2D[0] = Pointer1[0] | (Pointer1[3]<<16);
  regCOP2D[1] = Pointer1[6];

  rtv0(&regg);
  regT3 = regCOP2D[9] & 0xffff;
  regT4 = regCOP2D[10] << 16;
  regT5 = regCOP2D[11] & 0xffff;

  regCOP2D[0] = Pointer1[1] | (Pointer1[4]<<16);
  regCOP2D[1] = (signed short)Pointer1[7];

  rtv0(&regg);
  regT6 = (regCOP2D[9] << 16) | regT3;
  regT7 = regCOP2D[10] & 0xffff;
  regT8 = (regCOP2D[11] << 16) | regT5;

  regCOP2D[0] = Pointer1[2] | (Pointer1[5]<<16);
  regCOP2D[1] = Pointer1[8];

  rtv0(&regg);

  ((unsigned long*)Pointer1)[0] = regT6;
  ((unsigned long*)Pointer1)[1] = (regCOP2D[9] & 0xffff) | regT4;
  ((unsigned long*)Pointer1)[2] = (regCOP2D[10] << 16) | regT7;
  ((unsigned long*)Pointer1)[3] = regT8;
  ((unsigned long*)Pointer1)[4] = regCOP2D[11];

  regV0 = regA1;

  rPC = regRA;

  return(136);
}

int HLE_0051(void)
{
 rPC= regRA;
 return(70);
}

int HLE_0052(void)
{
 rPC= regRA;
 return(70);
}

int HLE_0053(void)
{
 regV0=2;
 rPC=regRA;
 return(200);
}

int HLE_0054(void)
{
 regSP+=0xFFFFFFC8;
 rPC+=4;
 return(4);
}

int HLE_0055(void)
{
 regSP+=0xFFFFFFC8;
 rPC+=4;
 return(4);
}

int HLE_0056(void)
{
  register unsigned long *Pointer0, *Pointer1,*Pointer2;;

  Pointer0 = GetAdressR(regA0);
  Pointer1 = GetAdressR(regA1);
  Pointer2 = GetAdressW(regA2);

  regCOP2C[0]= Pointer0[0];
  regCOP2C[1]= Pointer0[1];
  regCOP2C[2]= Pointer0[2];
  regCOP2C[3]= Pointer0[3];
  regCOP2C[4]= Pointer0[4];
  regT0=Pointer1[0];
  regT1=Pointer1[1];
  regT2=Pointer1[2];

  if ((signed long)regT0<0)
   {
    regT0=0-regT0;
    regT3=(signed long)regT0>>15;
    regT3=0-regT3;
    regT0&=0x7fff;
    regT0=0-regT0;
   }
  else
   {
    regT3=(signed long)regT0>>15;
    regT0&=0x7fff;
   }

  if ((signed long)regT1<0)
   {
    regT1=0-regT1;
    regT4=(signed long)regT1>>15;
    regT4=0-regT4;
    regT1&=0x7fff;
    regT1=0-regT1;
   }
  else
   {
    regT4=(signed long)regT1>>15;
    regT1&=0x7fff;
   }

  if ((signed long)regT2<0)
   {
    regT2=0-regT2;
    regT5=(signed long)regT2>>15;
    regT5=0-regT5;
    regT2&=0x7fff;
    regT2=0-regT2;
   }
  else
   {
    regT5=(signed long)regT2>>15;
    regT2&=0x7fff;
   }

  regCOP2D[9]=regT3;
  regCOP2D[10]=regT4;
  regCOP2D[11]=regT5;
  rtir0(&regg);
  regT3=regCOP2D[25];
  regT4=regCOP2D[26];
  regT5=regCOP2D[27];

  regCOP2D[9]=regT0;
  regCOP2D[10]=regT1;
  regCOP2D[11]=regT2;
  rtir(&regg);


  if ((signed long)regT3 < 0) regT3=-((-regT3)<<3);
  else regT3=regT3<<3;

  if ((signed long)regT4 < 0) regT4=-((-regT4)<<3);
  else regT4=regT4<<3;

  if ((signed long)regT5 < 0) regT5=-((-regT5)<<3);
  else regT5=regT5<<3;

  regT0=regCOP2D[25]+regT3;
  regT1=regCOP2D[26]+regT4;
  regT2=regCOP2D[27]+regT5;

  Pointer2[0]=regT0;
  Pointer2[1]=regT1;
  Pointer2[2]=regT2;

  regV0=regA2;
  rPC=regRA;
  return(180);
}

int HLE_0057(void)
{
 return(2);
}

int HLE_0058(void)
{
 return(2);
}

int HLE_0059(void)
{
 return(2);
}

int HLE_0060(void)
{
 return(2);
}

int HLE_0061(void)
{
 return(2);
}

int HLE_0062(void)
{
 return(2);
}

volatile int dmemcmp(void *d1, void *d2, int qq)
{
 register unsigned long i, *dd1=d1, *dd2=d2;
 qq=qq>>2;
 for (i=0; i<qq; i++)
   if ( (dd1[i]!=dd2[i]) && (dd2[i]!=0xffffffff) ) return(-1);

 return(0);
}

int ScanCode(unsigned long start, unsigned long finish, int *tester, unsigned long testlen)
{
 int i;

 finish-=testlen;

 for (i=start; i<finish; i++)
  if ( memcmp(psxM+(i*4),tester, testlen<<2) == 0) return(i);

 return(0);
}

int ScanCodeD(unsigned long start, unsigned long finish, int *tester, unsigned long testlen)
{
 int i;

 finish-=testlen;

 for (i=start; i<finish; i++)
  if ( dmemcmp(psxM+(i*4),tester, testlen<<2) == 0) return(i);

 return(0);
}

void ScanHLE(unsigned long a, unsigned long b)
{
 int i;

 if (NOHLE) return;

 a=a>>2; b=b>>2;

 i=ScanCode(a,b,TST_0001,20);
 if (i != 0) { ((int *)psxM)[i]=0xec000023; }

 i=ScanCode(a,b,TST_0002,22);
 if (i != 0) { ((int *)psxM)[i]=0xec000024; }

 i=ScanCode(a,b,TST_0003,9);
 if (i != 0) { ((int *)psxM)[i]=0xec000025; }

 i=ScanCode(a,b,TST_0004,33);
 if (i != 0) { ((int *)psxM)[i]=0xec000026; }

 i=ScanCode(a,b,TST_0005,50);
 if (i != 0) { ((int *)psxM)[i]=0xec000027; }

 i=ScanCode(a,b,TST_0006,30);
 if (i != 0) { ((int *)psxM)[i]=0xec000028; }

 i=ScanCodeD(a,b,TST_0007,10);
 if (i != 0) { ((int *)psxM)[i]=0xec000029; }

 i=ScanCode(a,b,TST_0008,67);
 if (i != 0) { ((int *)psxM)[i]=0xec00002a; }

 i=ScanCode(a,b,TST_0009,12);
 if (i != 0) { ((int *)psxM)[i]=0xec00002b; }

 i=ScanCode(a,b,TST_0010,8);
 if (i != 0) { ((int *)psxM)[i]=0xec00002c; }

 i=ScanCode(a,b,TST_0011,8);
 if (i != 0) { ((int *)psxM)[i]=0xec00002d; }

 i=ScanCodeD(a,b,TST_0012,64);
 if (i != 0) { ((int *)psxM)[i]=0xec00002e; }

 i=ScanCodeD(a,b,TST_0013,25);
 if (i != 0) { ((int *)psxM)[i]=0xec00002f; }
 i=ScanCodeD(a,b,TST_0013A,24);
 if (i != 0) { ((int *)psxM)[i]=0xec00002f; }

 i=ScanCodeD(a,b,TST_0014,15);
 if (i != 0) { ((int *)psxM)[i]=0xec000030; }
 i=ScanCodeD(a,b,TST_0014A,15);
 if (i != 0) { ((int *)psxM)[i]=0xec000030; }
 i=ScanCodeD(a,b,TST_0014B,15);
 if (i != 0) { ((int *)psxM)[i]=0xec000030; }
 i=ScanCodeD(a,b,TST_0014C,15);
 if (i != 0) { ((int *)psxM)[i]=0xec000030; }

 i=ScanCode(a,b,TST_0015,88);
 if (i != 0) { ((int *)psxM)[i]=0xec000031; }

 i=ScanCode(a,b,TST_0016,12);
 if (i != 0) { ((int *)psxM)[i]=0xec000032; }

 i=ScanCode(a,b,TST_0017,15);
 if (i != 0) { ((int *)psxM)[i]=0xec000033; }

 i=ScanCode(a,b,TST_0018,15);
 if (i != 0) { ((int *)psxM)[i]=0xec000034; }

 i=ScanCode(a,b,TST_0019,46);
 if (i != 0) { ((int *)psxM)[i]=0xec000035; }

 i=ScanCodeD(a,b,TST_0020,82);
 if (i != 0) { ((int *)psxM)[i]=0xec000037; }
 i=ScanCodeD(a,b,TST_0020B,94);
 if (i != 0) { ((int *)psxM)[i]=0xec000038; }
 i=ScanCodeD(a,b,TST_0020C,82);
 if (i != 0) { ((int *)psxM)[i]=0xec000037; }

 i=ScanCodeD(a,b,TST_0022,36);
 if (i != 0) { ((int *)psxM)[i]=0xec00003d; }
 i=ScanCodeD(a,b,TST_0022B,37);
 if (i != 0) { ((int *)psxM)[i]=0xec00003d; }

 i=ScanCodeD(a,b,TST_0023,50);
 if (i != 0) { ((int *)psxM)[i]=0xec00003e; }
 i=ScanCodeD(a,b,TST_0023B,46);
 if (i != 0) { ((int *)psxM)[i]=0xec00003e; }

 i=ScanCodeD(a,b,TST_0024,33);
 if (i != 0) { ((int *)psxM)[i]=0xec00003f; }

 i=ScanCodeD(a,b,TST_0025,37);
 if (i != 0) { ((int *)psxM)[i]=0xec000040; }

 i=ScanCodeD(a,b,TST_0026,22);
 if (i != 0) { ((int *)psxM)[i]=0xec000041; }

 i=ScanCode(a,b,TST_0027,13);
 if (i != 0) { ((int *)psxM)[i]=0xec000042; }

 i=ScanCodeD(a,b,TST_0028,10);
 if (i != 0) { ((int *)psxM)[i]=0xec000043; }

 i=ScanCode(a,b,TST_0029,15);
 if (i != 0) { ((int *)psxM)[i]=0xec000044; }

 i=ScanCode(a,b,TST_0029b,76);
 if (i != 0) { ((int *)psxM)[i]=0xec000045; }

 i=ScanCodeD(a,b,TST_0029c,164);
 if (i != 0) { ((int *)psxM)[i]=0xec000046; }

 i=ScanCode(a,b,TST_0030,12);
 if (i != 0) { ((int *)psxM)[i]=0xec000047; }

 i=ScanCode(a,b,TST_0031,11);
 if (i != 0) { ((int *)psxM)[i]=0xec000048; }

 i=ScanCodeD(a,b,TST_0032,23);
 if (i != 0) { ((int *)psxM)[i]=0xec000049; }

 i=ScanCode(a,b,TST_0033,88);
 if (i != 0) { ((int *)psxM)[i]=0xec00004a; }

 i=ScanCode(a,b,TST_0034,5);
 if (i != 0) { ((int *)psxM)[i]=0xec00004b; }
 i=ScanCode(a,b,TST_0035,5);
 if (i != 0) { ((int *)psxM)[i]=0xec00004c; }
 i=ScanCode(a,b,TST_0036,5);
 if (i != 0) { ((int *)psxM)[i]=0xec00004d; }
 i=ScanCode(a,b,TST_0037,5);
 if (i != 0) { ((int *)psxM)[i]=0xec00004e; }
 i=ScanCode(a,b,TST_0038,5);
 if (i != 0) { ((int *)psxM)[i]=0xec00004f; }
 i=ScanCode(a,b,TST_0039,5);
 if (i != 0) { ((int *)psxM)[i]=0xec000050; }

 i=ScanCode(a,b,TST_0041,12);
 if (i != 0) { ((int *)psxM)[i]=0xec000052; }

 i=ScanCode(a,b,TST_0042,73);
 if (i != 0) { ((int *)psxM)[i]=0xec000053; }

 i=ScanCode(a,b,TST_0043,78);
 if (i != 0) { ((int *)psxM)[i]=0xec000054; }

 i=ScanCodeD(a,b,TST_0044,50);
 if (i != 0) { H[5]=i<<2; ((int *)psxM)[i]=0xec000055; }
 i=ScanCodeD(a,b,TST_0044B,51);
 if (i != 0) { H[5]=i<<2; ((int *)psxM)[i]=0xec000055; }

 i=ScanCodeD(a,b,TST_0045,40);
 if (i != 0) { ((int *)psxM)[i]=0xec000056; }
 i=ScanCodeD(a,b,TST_0045B,40);
 if (i != 0) { ((int *)psxM)[i]=0xec000056; }

 i=ScanCode(a,b,TST_0048,16);
 if (i != 0) { ((int *)psxM)[i]=0xec000059; }

 i=ScanCode(a,b,TST_0049,67);
 if (i != 0) { ((int *)psxM)[i]=0xec00005a; }

 i=ScanCode(a,b,TST_0050,67);
 if (i != 0) { ((int *)psxM)[i]=0xec00005b; }

 i=ScanCodeD(a,b,TST_0053,51);
 if (i != 0) { ((int *)psxM)[i]=0xec00005e;  }

 i=ScanCodeD(a,b,TST_0053A,48);
 if (i != 0) { ((int *)psxM)[i]=0xec00005e;  }

 i=ScanCode(a,b,TST_0056,88);
 if (i != 0) { ((int *)psxM)[i]=0xec000061;  }


}
