#define	RAMADDR(addr) ((void*)&psxM[(addr)&0x1fffff])

unsigned long CDAPLAYING=0;
static UINT8 *CD_Read(UINT8 *cdloc);
UINT8 *ISO_Read(UINT8 *cdloc);

void CD_Play(UINT8 *cdloc)
{
 char dato[256];
 if (CDAPLAYING) { return; }
 if (!(CDADEC)) return;

 MCI__send("Stop CDAudio");
 MCI__send("Close CDAudio");
 MCI__send("Open CDAudio");
 MCI__send("Set CDAudio Time Format msf");
 sprintf (dato, "Play CDAudio from %d:%d:%d", cdloc[0], cdloc[1]+3, cdloc[2]);
 MCI__send(dato);
 CDAPLAYING=1;
}

void CD_Stop(void)
{
 if (!(CDADEC)) return;
 MCI__send("Stop CDAudio");
 MCI__send("Close CDAudio");
 CDAPLAYING=0;
 return;
}

static UINT8 *CD_Read(UINT8 *cdloc)
{
            unsigned char tst[4];

            if (CDISO)
             {
              RAWCDROM = ISO_Read(cdloc);
              if (((signed long*)RAWCDROM)[6]==0x80010160)
                {
                 cdFile=1; cdChannel=1;
                }
              else if ( (((long*)RAWCDROM)[4]==((long*)RAWCDROM)[5]) && (((char*)RAWCDROM)[18] == 0x64) )
                { doXA(); }
              return((void *)RAWCDROM+12);
             }

            tst[0]=INT2BCD(cdloc[0]);
            tst[1]=INT2BCD(cdloc[1]);
            tst[2]=INT2BCD(cdloc[2]);
            tst[3]=INT2BCD(cdloc[3]);
            CDR_readTrack(tst);
            RAWCDROM= CDR_getBuffer();
            RAWCDROM=RAWCDROM-12;

            if (((signed long*)RAWCDROM)[6]==0x80010160)
              { cdFile=1; cdChannel=1; if (MDECSKIP) MDECSKIP=2; }
            else if ( (((long*)RAWCDROM)[4]==((long*)RAWCDROM)[5]) && (((char*)RAWCDROM)[18] == 0x64) )
              { doXA(); }

            return((void *)RAWCDROM+12);
}

#define CdlSync         0
#define CdlNop	        1
#define CdlSetloc	2
#define CdlPlay	        3
#define CdlForward	4
#define CdlBackward	5
#define CdlReadN	6
#define CdlStandby	7
#define CdlStop	        8
#define CdlPause        9
#define CdlInit 	10
#define CdlMute	        11
#define CdlDemute	12
#define CdlSetfilter	13
#define CdlSetmode	14
#define CdlGetmode      15
#define CdlGetlocL	16
#define CdlGetlocP	17
#define Cdl18     	18
#define CdlGetTN	19
#define CdlGetTD	20
#define CdlSeekL	21
#define CdlSeekP	22
#define Cdl23     	23
#define Cdl24     	24
#define CdlTest 	25
#define CdlID   	26
#define CdlReadS	27
#define CdlReset	28
#define Cdl29     	29
#define CdlReadToc      30

#define cdREFRESH \
 if(cdResultReady && cdResultC) \
  { psxH[0x1800]|=0x20; \
    psxH[0x1801] = cdResult[cdResultP]; } \
 else { psxH[0x1800]&=0xdf; psxH[0x1801] = 0; }

unsigned long RcdREG0(void)
{

    cdREFRESH
    if (cdOCUP) psxH[0x1800]|=0x40;
    else psxH[0x1800]&=0xbf;

    return (psxH[0x1800] | 0x18);
}

void WcdREG0(unsigned long rt)
{
    cdREFRESH
    if (rt == 0) 
     { 
      cdParamP = cdParamC = cdResultReady=0; }
    else
    {
     if (rt & 0x01)
      {
       cdResultReady = 1;
       if (rt == 0x01) cdReset = 1;
      }
    }
}

unsigned long RcdREG1(void)
{
cdREFRESH
  if (cdResultReady)
   {
    cdResultP++;
    if (cdResultP==cdResultC) cdResultReady = 0;
   }
  return (psxH[0x1801]);
}

void WcdREG1(unsigned long rt)
{
    unsigned long register cdCmd, i;
    cdREFRESH
    psxH[0x1801] = rt;
    cdCmd = rt;

    if (cdCmd<32)
     {
      psxHL[0x1070>>2]|=0x4;
      if (psxHL[0x1074>>2]&0x4)
       {
        hardInterrupt=1;
        hardDMA=psxHL[0x1100>>2]+30;
       }

     }

    switch(cdCmd)
     {
      case CdlSync:
       cdResultP = 0; cdResultC = 1; cdResultReady=1;
       cdStat = 2; cdResult[0] = 2;
       cdOCUP=0;
      break;

      case CdlNop:
       cdResultP = 0; cdResultC = 1; cdResultReady=1;
       cdStat = 2; cdResult[0] = 0x2;
       cdOCUP=0;
       if (cdV != 0xffffffff)
        {
         cdOCUP=1;
         cdResult[0] = 0x22;
         cdV+=5;
        }
      break;

      case CdlSetloc:
       for(i=0;i<3;i++) cdSetSector[i] = BCD2INT(cdParam[i]);
       cdSetSector[3]=0;
       if ((cdSetSector[0]|cdSetSector[1]|cdSetSector[2]) == 0)
       {
         ((unsigned long *)cdSetSector)[0] = ((unsigned long *)cdSetSectorSeek)[0];
       }
       cdResultP = 0; cdResultC = 1; cdResultReady=1;
       cdStat = 2;
       cdResult[0] = 0x22;
       cdOCUP=1;
       break;

      case CdlPlay:
       cdResultP = 0; cdResultC = 1;
       cdResult[0] = 0x80; cdStat = 0x2;
       cdPlay=1;
       CD_Play(cdSetSector);
       break;

      case CdlForward:
       cdResultP = 0; cdResultC = 1; cdResultReady=1;
       cdStat = 2; cdResult[0] = 2;
       cdOCUP=0;
      break;

      case CdlBackward:
       cdResultP = 0; cdResultC = 1; cdResultReady=1;
       cdStat = 2; cdResult[0] = 2;
       cdOCUP=0;
      break;

      case CdlReadN:
       cdResultP = 0; cdResultC = 1; cdResultReady=1;
       cdResult[0] = 0x22;
       cdStat = 2;
       cdV=temporizer+95;
       cdOCUP=1; rread=1; cdpos=0;
       break;

      case CdlStandby:
       cdResultP = 0; cdResultC = 1; cdResultReady=1;
       cdStat = 2; cdResult[0] = 2;
       cdOCUP=0;
      break;

      case CdlStop:
       cdResultP = 0;
       cdResultC = 1;
       cdResult[0] = 0x22;
       cdResultReady=1;
       cdOCUP=0;
       cdStat = 2;

       CD_Stop();
       break;

      case CdlPause:
       cdResultP = 0;
       cdResultC = 1;
       cdResult[0] = 0x22;
       cdResultReady=1;
       if (cdpos !=0) cdOCUP=0;

       cdStat = 2;

       cdV = 0xffffffff;

       if (cdReaded>10)
        {
         setmeml((void*)PSXused, TENER, 0x1fffff>>2 );
         asm("movl $_PSXcode, _NextFree");
        }
       cdReaded=0;

       CD_Stop();
       break;

      case CdlInit:
       cdResultP = 0;
       cdResultC = 1;
       cdResult[0] = 0x22;
       cdStat = 2;
       cdResultReady=1;
       cdOCUP=0;
       break;

      case CdlMute:
       cdResultP = 0; cdResultC = 1; cdResultReady=1;
       cdStat = 2; cdResult[0] = 2;
       cdOCUP=0;
       cdMuted=0;
      break;

      case CdlDemute:
       cdResultP = 0; cdResultC = 1; cdResultReady=1;
       cdStat = 2; cdResult[0] = 2;
       cdOCUP=0;
       cdMuted=1;
       break;

      case CdlSetfilter:
       cdFile = cdParam[0];
       cdChannel = cdParam[1];
       cdResultP = 0; cdResultC = 1; cdResultReady=1;
       cdStat = 2; cdResult[0] = 2;
       cdOCUP=0;
      break;

      case CdlSetmode:
       cdMode = cdParam[0];
       cdResultP = 0; cdResultC = 1; cdResultReady=1;
       cdStat = 2; cdResult[0] = 0x22;
       if (cdMode&0x80) delayCD=delayCD2X; else delayCD=delayCD1X;
       cdOCUP=0;
       break;

      case CdlGetmode:
       cdResultP = 0;
       cdResultC = 6;
       cdResult[0] = 0x02;
       cdResult[1] = cdMode;
       cdResult[2] = cdFile;
       cdResult[3] = cdChannel;
       cdResult[4] = 0;
       cdResult[5] = 0;
       cdStat = 2;
       cdResultReady=1;
       cdOCUP=0;
       break;

      case CdlGetlocL:
       cdResultP = 0; cdResultC = 6; cdResultReady=1;
       cdResult[0] = 0x00;
       cdResult[1] = 0x00;
       cdResult[2] = 0x00;
       cdResult[3] = cdMode;
       cdResult[4] = cdFile;
       cdResult[5] = cdChannel;
       cdStat = 2;
       cdOCUP=0;
       if (cdV != 0xffffffff) cdV+=2;
       break;

      case CdlGetlocP:
       cdResultP = 0; cdResultC = 8; cdResultReady=1;
       cdResult[0] = 2;
       cdResult[1] = 1;
       cdResult[2] = 0x00;
       cdResult[3] = 0xff;
       cdResult[4] = 0xff;
       cdResult[5] = 0xff;
       cdResult[6] = 0xff;
       cdResult[7] = 0xff;
       cdStat = 2;
       cdOCUP=0;
       if (cdV != 0xffffffff) cdV+=2;
      break;

      case CdlGetTN:
       if (CDISO)
        {
         cdResultP = 0; cdResultC = 3; cdResultReady=1;
         cdStat = 2;
         cdResult[0] = 0x2;
         cdResult[1] = 1;
         cdResult[2] = 1;
         cdOCUP=0;
        }
       else
        {
         CDR_getTN(cdResultTN);
         cdResultP = 0; cdResultC = 3; cdResultReady=1;
         cdStat = 2;
         cdResult[0] = 0x2;
         cdResult[1] = cdResultTN[0];
         cdResult[2] = cdResultTN[1];
         cdOCUP=0;
        }
       break;

      case CdlGetTD:
       if (CDISO)
        {
         cdResultP = 0;
         cdResultC = 4;
         cdResultReady=1;
         cdStat = 2;
         cdResult[0] = 0;
         cdResult[1] = 1;
         cdResult[2] = 1;
         cdResult[3] = 1;
         cdOCUP=0;
        }
       else
        {
         cdTrack = (cdParam[0]>>4)*10+cdParam[0]&0xf;
         CDR_getTD(cdTrack, cdResultTD);
         cdResultP = 0;
         cdResultC = 4;
         cdResultReady=1;
         cdStat = 2;
         cdResult[0] = 0;
         cdResult[1] = INT2BCD(cdResultTD[0]);
         cdResult[2] = INT2BCD(cdResultTD[1]);
         cdResult[3] = INT2BCD(cdResultTD[2]);
         cdOCUP=0;
        }
       break;

      case CdlSeekL:
       cdResultP = 0; cdResultC = 1; cdResultReady=1;
       cdResult[0] = 0x22;
       cdStat = 2;
       cdOCUP=0;
       ((unsigned long *)cdSetSectorSeek)[0] = ((unsigned long *)cdSetSector)[0];
      break;

      case CdlSeekP:
       cdResultP = 0; cdResultC = 1; cdResultReady=1;
       cdResult[0] = 0x22;
       cdStat = 2;
       cdOCUP=0;
       ((unsigned long *)cdSetSectorSeek)[0] = ((unsigned long *)cdSetSector)[0];
       break;

      case CdlReadS:
       cdResultP = 0; cdResultC = 1; cdResultReady=1;
       cdResult[0] = 0x22;
       cdStat = 2;
       cdV=temporizer+95;
       cdOCUP=0;
       rread=1; cdpos=0;
       break;

      case CdlReset:
       cdResultP = 0;
       cdResultC = 1;
       cdResult[0] = 0x22;
       cdStat = 2;
       cdResultReady=1;
       cdOCUP=0;
       break;

      case CdlReadToc:
       cdResultP = 0;
       cdResultC = 1;
       cdResult[0] = 0x22;
       cdStat = 2;
       cdResultReady=1;
       cdOCUP=0;
       break;

      case CdlTest:
        switch(cdParam[0])
         {
         case 0x20:
         cdResultReady=1;
         cdResultP=0;
         cdResultC=4;
         cdResult[0]=0x94;
         cdResult[1]=0x09;
         cdResult[2]=0x19;
         cdResult[3]=0xc0;
         cdStat=3;
         cdOCUP=0;
         break;
         }
       break;

      case CdlID:
         cdResultReady=1;
         cdResultP=0;
         cdResultC=8;
         cdResult[0]=0x00;
         cdResult[1]=0x00;
         cdResult[2]=0x00;
         cdResult[3]=0x00;
         cdResult[4]='S';
         cdResult[5]='C';
         cdResult[6]='E';
         cdResult[7]='A';
         cdStat=2;
         cdOCUP=0;
      break;
     }

}

unsigned long RcdREG2(void)
{
  return (0);
}

void WcdREG2(unsigned long rt)
{
    psxH[0x1802] = rt;

    if ((cdReset == 2) && (rt == 0x07))
     {
      cdParamP=0; cdParamC=0; cdResultReady=0; cdReset = 0;
      cdStat = 0;
      psxH[0x1800] = 0;
      psxH[0x1800] = psxH[0x1800] & ~3;
     }
     else
     {
    cdReset=0;
    cdParam[cdParamP++] = rt;
    cdParamC++;
    if (cdParamP>7)
     {
      cdParamP=7;
      cdParamC=7;
     }
    }
}

unsigned long RcdREG3(void)
{
  return (cdStat);
}

void WcdREG3(unsigned long rt)
{
   if (( rt == 0x07) && (cdReset == 1)) cdReset = 2;
   else cdReset = 0;
   if (cdResultReady && (rt == 7)) { cdResultC=0; cdStat = 0; }
}
