#define IDM_NONE        000
#define IDM_BOOT        101
#define IDM_LOAD        102
#define IDM_START       103
#define IDM_LOADSTATE   104
#define IDM_QUIT        105
#define IDM_GPU         110
#define IDM_SPU         111
#define IDM_CDR         112
#define IDM_BIOS        113
#define IDM_CPU         114
#define IDM_PAD         115
#define IDM_ABOUT       120
#define IDM_ISO         130

typedef struct {
	UINT32	cpr2[32];
	UINT32	ccr2[32];
} R3000_REG;
#define	CPR2	regg.cpr2
#define	CCR2	regg.ccr2

char PSXloaded[256];

void opNI(void);
void opFUNC(void);
void opREGGIM(void);

void opJ(void);
void opJAL(void);
void opBEQ(void);
void opBEQL(void);
void opBNE(void);
void opBLEZ(void);
void opBGTZ(void);
void opADDI(void);
void opADDIU(void);
void opSLTI(void);
void opSLTIU(void);
void opANDI(void);
void opORI(void);
void opXORI(void);
void opLUI(void);
void opCOP0(void);
void opCOP2(void);
void opLB(void);
void opLH(void);
void opLWL(void);
void opLW(void);
void opLBU(void);
void opLHU(void);
void opLWR(void);
void opSB(void);
void opSH(void);
void opSWL(void);
void opSW(void);
void opSWR(void);
void opLWC2(void);
void opSWC2(void);
void opAND(void);
void opOR(void);
void opXOR(void);
void opNOR(void);
void opSLL(void);
void opSRL(void);
void opSRA(void);
void opSLLV(void);
void opSRLV(void);
void opSRAV(void);
void opJR(void);
void opJALR(void);
void opSYSCALL(void);
void opBREAK(void);
void opMULT(void);
void opMULTU(void);
void opDIV(void);
void opDIVU(void);
void opMFHI(void);
void opMTHI(void);
void opMFLO(void);
void opMTLO(void);
void opADD(void);
void opADDU(void);
void opSUB(void);
void opSUBU(void);
void opSLT(void);
void opSLTU(void);
void opBLTZ(void);
void opBGEZ(void);
void opBLTZAL(void);
void opBGEZAL(void);
void opHLE(void);

void (*opF[64])(void) = {opFUNC,opREGGIM,opJ,opJAL,opBEQ,opBNE,opBLEZ,opBGTZ,
			 opADDI,opADDIU,opSLTI,opSLTIU,opANDI,opORI,opXORI,opLUI,
			 opCOP0,opNI,opCOP2,opNI,opBEQL,opNI,opNI,opNI,
			 opNI,opNI,opNI,opNI,opNI,opNI,opNI,opNI,
			 opLB,opLH,opLWL,opLW,opLBU,opLHU,opLWR,opNI,
			 opSB,opSH,opSWL,opSW,opNI,opNI,opSWR,opNI,
			 opNI,opNI,opLWC2,opNI,opNI,opNI,opNI,opNI,
			 opNI,opNI,opSWC2,opHLE,opNI,opNI,opNI,opNI};

void (*opFS[64])(void) = {opSLL,opNI,opSRL,opSRA,opSLLV,opNI,opSRLV,opSRAV,
			 opJR,opJALR,opNI,opNI,opSYSCALL,opBREAK,opNI,opNI,
			 opMFHI,opMTHI,opMFLO,opMTLO,opNI,opNI,opNI,opNI,
			 opMULT,opMULTU,opDIV,opDIVU,opNI,opNI,opNI,opNI,
			 opADD,opADDU,opSUB,opSUBU,opAND,opOR,opXOR,opNOR,
			 opNI,opNI,opSLT,opSLTU,opNI,opNI,opNI,opNI,
			 opNI,opNI,opNI,opNI,opNI,opNI,opNI,opNI,
			 opNI,opNI,opNI,opNI,opNI,opNI,opNI,opNI};

void (*opFR[32])(void) = {opBLTZ,opBGEZ,opNI,opNI,opNI,opNI,opNI,opNI,
			 opNI,opNI,opNI,opNI,opNI,opNI,opNI,opNI,
			 opBLTZAL,opBGEZAL,opNI,opNI,opNI,opNI,opNI,opNI,
			 opNI,opNI,opNI,opNI,opNI,opNI,opNI,opNI};

unsigned char psxM[2*1024*1034] asm("psxM");
unsigned char psxH[64*1024]     asm("psxH");
#include "psxdev.h"
unsigned char psxR[512*1024] asm("psxR");

unsigned long rPC asm("rPC");
unsigned long reg[32];
unsigned long regCOP0[32];
R3000_REG regg asm("_regg");
signed long regLO asm("_regLO");
signed long regHI asm("_regHI");

#define psxSL ((unsigned long*)psxS)
#define psxSLS ((signed long*)psxS)
#define psxSW ((unsigned short*)psxS)
#define psxSWS ((signed short*)psxS)

#define psxHL ((unsigned long*)psxH)
#define psxHLS ((signed long*)psxH)
#define psxHW ((unsigned short*)psxH)
#define psxHWS ((signed short*)psxH)

#define psxML ((unsigned long*)psxM)
#define psxMLS ((signed long*)psxM)
#define psxMW ((unsigned short*)psxM)
#define psxMWS ((signed short*)psxM)

#define psxRL ((unsigned long*)psxR)
#define psxRLS ((signed long*)psxR)
#define psxRW ((unsigned short*)psxR)
#define psxRWS ((signed short*)psxR)

#define regS ((signed long*)reg)

void CD_Play(UINT8 *cdloc);
void CD_Stop(void);

unsigned long *psxMEM[0x10000] asm("_psxMEM");
unsigned long *psxMEMW[0x10000] asm("_psxMEMW");
unsigned long trashMEM[0x10000] asm("_trashMEM");
unsigned long trashMEMW[0x10000] asm("_trashMEMW");

FILE *tempfile;

#define DMA_ACTIVE(n) (psxHL[0x10F0>>2]&(8<<(n*4)))

#define isRAM(adr) ((adr>=0x00000000 && adr<=0x007fffff) || (adr>=0x80000000 && adr<=0x807fffff) || (adr>=0xa0000000 && adr<=0xa07fffff))
#define isINRAM(adr,size) ((isRAM(adr)) && (((adr&0x1ffffff)+size)<0x1fffff))

void salDOS(char *bye)
{
 if (Runt)
 {
  FreeLibrary(hGPUDriver);
  FreeLibrary(hMCIDriver);
  FreeLibrary(hPADDriver);
  FreeLibrary(hCDDriver);
  FreeLibrary(hSPUDriver);
  if (CDADEC) CD_Stop();
 }
 if (bye[0]!='\n') MessageBox (opio, bye, adripsx_id, MB_OK | MB_ICONASTERISK);
 exit(0);
}

void CleanRec(unsigned long adres, unsigned long size)
{
if (CPUTYPE) return;

adres=((adres&0x1fffff)>>2)-16;
size=((size>>2)+32);

if ( adres > (0x1fffff>>2) ) adres=0;
if ( (adres+size) >(0x1fffff>>2) ) size=(0x200000>>2)-adres;
setmeml((void*)PSXused+(adres<<2), TENER, size);
}

static void DMAintr(unsigned long aa)
{
if (psxHL[0x10f4>>2]&(aa<<16))
 {
  psxHL[0x10F4>>2] |= (aa << 24) | 0x80000000;
  psxHL[0x1070>>2] |= 8;
  if (psxHL[0x1074>>2]&8)
   {
    if (aa&0x06) hardDMA=psxHL[0x1100>>2]+350;
    if ((psxHL[0x10F4>>2]>>24) ==0x86) psxHL[0x10F4>>2]&=0xfbffffff;
    hardInterrupt=1;
   }
 }
}

char dCD;
unsigned char *RAWCDROM;

static void incSector(void)
{
 cdSetSector[2]++;
 if(cdSetSector[2] == 75)
  {
   cdSetSector[2] = 0;
   cdSetSector[1]++;
   if(cdSetSector[1] == 60)
    {
     cdSetSector[1] = 0;
     cdSetSector[0]++;
    }
  }
}
