unsigned char BU00N[256];
unsigned char BU00D[131072];
unsigned long BU00P;

unsigned char BU01N[256];
unsigned char BU01D[131072];
unsigned long BU01P;

int InitCard(void);
int UpdateCard(void);
int OpenCard(unsigned char *FileName, unsigned long mode);
void ReadCard(void *Adress, unsigned long Size);
void WriteCard(void *Adress, unsigned long Size);
int DeleteCard(unsigned char *FileName);


int InitCard(void)
{
 FILE *tfile;

 sprintf (BU00N, "000.mcr");
 sprintf (BU01N, "001.mcr");

 tfile=fopen(BU00N,"rb");
 if (tfile==NULL) return(-1);
 fread(BU00D,131072,1,tfile);
 fclose(tfile);

 tfile=fopen(BU01N,"rb");
 if (tfile==NULL) return(-1);
 fread(BU01D,131072,1,tfile);
 fclose(tfile);

 return(0);
}

int OpenCard(unsigned char *FileName, unsigned long mode)
{
 register int i;

 for (i=1; i<16; i++)
   if (_strnicmp(FileName,BU00D+(10+(i*128)),16)==0) break;

 if (i==16)
  {
   if (mode == 1) return(-1);
   if ((mode == 0) || (mode == 2))
    {
     register int aa;

     for (aa=1; aa<16; aa++)
       if (BU00D[10+(aa*128)]==0) break;

     if (aa==16)
     {
      return(-1);
     }

     BU00D[aa*128]=81;
     sprintf (BU00D+(10+(aa*128)), "%s", FileName);
     BU00D[127+(aa*128)]=112;
     memset(BU00D+(i*8192),0,8192);
     i=aa;
    }
   else
    {
     return(-1);
    }
  }

 BU00P=8192*i;
 return(0);
}

void ReadCard(void *Adress, unsigned long Size)
{
 memcpy(Adress, BU00D+(BU00P), Size);
 BU00P+=Size;
}

void WriteCard(void *Adress, unsigned long Size)
{
 memcpy(BU00D+(BU00P), Adress, Size);
 UpdateCard();
 BU00P+=Size;
}

int DeleteCard(unsigned char *FileName)
{
return(0);
}

int UpdateCard(void)
{
 FILE *tfile;
 tfile=fopen(BU00N,"wb");
 if (tfile==NULL) return(-1);
 fwrite(BU00D,131072,1,tfile);
 fclose(tfile);

 tfile=fopen(BU01N,"wb");
 if (tfile==NULL) return(-1);
 fwrite(BU01D,131072,1,tfile);
 fclose(tfile);

 return(0);
}
