HINSTANCE		hMCIDriver;
typedef long (CALLBACK*MCIsend)(LPCTSTR, LPTSTR, unsigned long, HWND);

MCIsend MCI_send = NULL;

static void LoadMCIplugin()
{
	hMCIDriver = LoadLibrary("winmm.dll");
	if(hMCIDriver==NULL)
	{
                MessageBox(0, "Couln't load MCI controller.", "ERROR", MB_ICONSTOP);
		exit(-1);
	}
    MCI_send = (MCIsend)GetProcAddress(hMCIDriver,"mciSendStringA");
}

static long MCI__send(LPCTSTR text)
{
	return(MCI_send(text,NULL,0,NULL));
}

HINSTANCE		hGUIDriver;
typedef long (*lpGUI_GET)(void);
typedef long (*lpGUI_GPU)(unsigned long);
typedef long (*lpGUI_SPU)(unsigned long);
typedef long (*lpGUI_CDR)(unsigned long);
typedef long (*lpGUI_PAD)(unsigned long);
typedef long (*lpGUI_CPU)(unsigned long);

lpGUI_GPU GUI_GPU;
lpGUI_SPU GUI_SPU;
lpGUI_CDR GUI_CDR;
lpGUI_PAD GUI_PAD;
lpGUI_CPU GUI_CPU;
lpGUI_GET GUI_GET;

void LoadGUIplugin()
{
	hGUIDriver = LoadLibrary("AdriGUI.dll");
	if(hGUIDriver==NULL)
	{
                MessageBox(0, "Couln't load GUI Plugin.", "ERROR", MB_ICONSTOP);
		exit(-1);
	}
       GUI_GPU = (lpGUI_GPU)GetProcAddress(hGUIDriver,"GUI_GPU");
       GUI_SPU = (lpGUI_SPU)GetProcAddress(hGUIDriver,"GUI_SPU");
       GUI_CDR = (lpGUI_CDR)GetProcAddress(hGUIDriver,"GUI_CDR");
       GUI_PAD = (lpGUI_PAD)GetProcAddress(hGUIDriver,"GUI_PAD");
       GUI_CPU = (lpGUI_CPU)GetProcAddress(hGUIDriver,"GUI_CPU");
       GUI_GET = (lpGUI_GET)GetProcAddress(hGUIDriver,"GUI_GET");

}

static void GetConfig (void)
{
 GUI_GET();
}

static long GPUset(unsigned long val)
{
	return(GUI_GPU(val));
}

static long SPUset(unsigned long val)
{
	return(GUI_SPU(val));
}

static long CDRset(unsigned long val)
{
	return(GUI_CDR(val));
}

static long PADset(unsigned long val)
{
	return(GUI_PAD(val));
}

static long CPUset(unsigned long val)
{
	return(GUI_CPU(val));
}


typedef unsigned long (CALLBACK*PADinit)(unsigned long);
typedef void (CALLBACK*PADshutdown)(void);
typedef unsigned long (CALLBACK*PADopen)(HWND);
typedef unsigned long (CALLBACK*PADclose)(void);
typedef unsigned long (CALLBACK*PADconfigure)(void);
typedef void (CALLBACK*PADabout)(void);
typedef unsigned long (CALLBACK*PADquery)(void);
typedef unsigned long (CALLBACK*PADreadPort1)(PadDataS *);
typedef unsigned long (CALLBACK*PADreadPort2)(PadDataS *);

typedef void (CALLBACK*GPUwriteStatus)(unsigned long);
typedef void (CALLBACK*GPUwriteData)(unsigned long);
typedef unsigned long (CALLBACK*GPUreadStatus)();
typedef unsigned long (CALLBACK*GPUreadData)();
typedef long (CALLBACK* GPUinit)();
typedef long (CALLBACK* GPUshutdown)();
typedef long (CALLBACK* GPUopen)(HWND);
typedef long (CALLBACK* GPUclose)();
typedef void (CALLBACK* GPUupdateLace)(void);
typedef long (CALLBACK* GPUconfigure)(void);
typedef void (CALLBACK* GPUdmaChain)(unsigned long *,unsigned long);
typedef void (CALLBACK* GPUwriteDataMem)(unsigned long *,unsigned long);
typedef void (CALLBACK* GPUfreeze)(unsigned long , void *);

typedef long (CALLBACK* CDRinit)(void);
typedef long (CALLBACK* CDRshutdown)(void);
typedef long (CALLBACK* CDRopen)(void);
typedef long (CALLBACK* CDRclose)(void);
typedef long (CALLBACK* CDRgetTN)(unsigned char *);
typedef long (CALLBACK* CDRgetTD)(unsigned char , unsigned char *);
typedef long (CALLBACK* CDRreadTrack)(unsigned char *);
typedef unsigned char * (CALLBACK* CDRgetBuffer)(void);
typedef long (CALLBACK* CDRconfigure)(void);
typedef long (CALLBACK* CDRabout)(void);

typedef long (CALLBACK* SPUconfigure)(void);
typedef void (CALLBACK* SPUabout)(void);
typedef long (CALLBACK* SPUinit)(void);				
typedef long (CALLBACK* SPUshutdown)(void);	
typedef long (CALLBACK* SPUopen)(HWND);
typedef long (CALLBACK* SPUclose)(void);			
typedef void (CALLBACK* SPUplaySample)(unsigned char);		
typedef void (CALLBACK* SPUstartChannels1)(unsigned short);	
typedef void (CALLBACK* SPUstartChannels2)(unsigned short);
typedef void (CALLBACK* SPUstopChannels1)(unsigned short);	
typedef void (CALLBACK* SPUstopChannels2)(unsigned short);	
typedef void (CALLBACK* SPUputOne)(unsigned long,unsigned short);			
typedef unsigned short (CALLBACK* SPUgetOne)(unsigned long);			
typedef void (CALLBACK* SPUsetAddr)(unsigned char, unsigned short);			
typedef void (CALLBACK* SPUsetPitch)(unsigned char, unsigned short);		
typedef void (CALLBACK* SPUsetVolumeL)(unsigned char, short );		
typedef void (CALLBACK* SPUsetVolumeR)(unsigned char, short );		
typedef void (CALLBACK* SPUwriteRegister)(unsigned long,unsigned short);
typedef unsigned short (CALLBACK* SPUreadRegister)(unsigned long);
typedef void (CALLBACK* SPUwriteDMA)(unsigned short);
typedef unsigned short (CALLBACK* SPUreadDMA)(void);
typedef void (CALLBACK* SPUplayADPCMchannel)(xa_decode_t *);
typedef void (CALLBACK* SPUfreeze)(unsigned long , void *);


HINSTANCE		hPADDriver;

PADinit          PAD_init           = NULL;
PADshutdown      PAD_shutdown       = NULL;
PADopen          PAD_open           = NULL;
PADclose         PAD_close          = NULL;
PADconfigure     PAD_configure      = NULL;
PADabout         PAD_about          = NULL;
PADquery         PAD_query          = NULL;
PADreadPort1     PAD_readPort1      = NULL;
PADreadPort2     PAD_readPort2      = NULL;

HINSTANCE		hGPUDriver;

GPUupdateLace    GPU_updateLace     = NULL;
GPUinit          GPU_init           = NULL;
GPUshutdown      GPU_shutdown       = NULL; 
GPUconfigure     GPU_configure      = NULL;
GPUopen          GPU_open           = NULL;
GPUclose         GPU_close          = NULL;
GPUreadStatus    GPU_readStatus     = NULL;
GPUreadData      GPU_readData       = NULL;
GPUwriteStatus   GPU_writeStatus    = NULL; 
GPUwriteData     GPU_writeData      = NULL;
GPUdmaChain      GPU_dmaChain       = NULL;
GPUwriteDataMem  GPU_writeDataMem   = NULL;
GPUfreeze        GPU_freeze         = NULL;

void LoadPADplugin()
{
	hPADDriver = LoadLibrary(Configuracion.PADplugin);
	if(hPADDriver==NULL)
	{
                MessageBox(0, "Couln't load PAD Plugin.", "ERROR", MB_ICONSTOP);
		exit(-1);
	}
    PAD_init = (PADinit)GetProcAddress(hPADDriver,"PADinit");
    PAD_shutdown = (PADshutdown)GetProcAddress(hPADDriver,"PADshutdown");
    PAD_open = (PADopen)GetProcAddress(hPADDriver,"PADopen");
    PAD_close = (PADclose)GetProcAddress(hPADDriver,"PADclose");
    PAD_configure = (PADconfigure)GetProcAddress(hPADDriver,"PADconfigure");
    PAD_about = (PADabout)GetProcAddress(hPADDriver,"PADabout");
    PAD_query = (PADquery)GetProcAddress(hPADDriver,"PADquery");
    PAD_readPort1 = (PADreadPort1)GetProcAddress(hPADDriver,"PADreadPort1");
    PAD_readPort2 = (PADreadPort2)GetProcAddress(hPADDriver,"PADreadPort2");
}

void LoadGPUplugin()
{
	hGPUDriver = LoadLibrary(Configuracion.GPUplugin);
	if(hGPUDriver==NULL)
	{
                MessageBox(0, "Couln't load GPU Plugin.", "ERROR", MB_ICONSTOP);
		exit(-1);
	}
    GPU_init = (GPUinit)GetProcAddress(hGPUDriver,"GPUinit");
    GPU_shutdown  = (GPUshutdown)GetProcAddress(hGPUDriver,"GPUshutdown");
    GPU_configure =(GPUconfigure)GetProcAddress(hGPUDriver,"GPUconfigure");
    GPU_open = (GPUopen)GetProcAddress(hGPUDriver,"GPUopen");
    GPU_close = (GPUclose)GetProcAddress(hGPUDriver,"GPUclose");
    GPU_readStatus = (GPUreadStatus)GetProcAddress(hGPUDriver,"GPUreadStatus");
    GPU_readData = (GPUreadData)GetProcAddress(hGPUDriver,"GPUreadData");
    GPU_writeStatus = (GPUwriteStatus)GetProcAddress(hGPUDriver,"GPUwriteStatus");
    GPU_writeData = (GPUwriteData)GetProcAddress(hGPUDriver,"GPUwriteData");
    GPU_dmaChain = (GPUdmaChain)GetProcAddress(hGPUDriver,"GPUdmaChain");
    GPU_updateLace = (GPUupdateLace)GetProcAddress(hGPUDriver,"GPUupdateLace");
    GPU_writeDataMem = (GPUwriteDataMem)GetProcAddress(hGPUDriver,"GPUwriteDataMem");
    GPU_freeze= (GPUfreeze)GetProcAddress(hGPUDriver,"GPUfreeze");
}

static void GPU__freeze(unsigned long a, void *b)
{
        if (GPU_freeze == NULL) return;
        GPU_freeze(a,b);
}

long GPU__init()
{
    if(GPU_init == NULL)
	{
                MessageBox(0, "Couldn't load GPU Plugin", "ERROR", MB_ICONSTOP);
		exit(-1);
	}
	return GPU_init();
}
static long GPU__open(HWND hWnd)
{
	return GPU_open(hWnd);
}
static long GPU__close()
{
	return GPU_close();
}
void GPU__writeStatus(unsigned long data)
{
	GPU_writeStatus(data);
}
void GPU__writeData(unsigned long data)
{
	GPU_writeData(data);
}
void GPU__writeDataMem(unsigned long * pMem, unsigned long iSize)
{
	GPU_writeDataMem(pMem,iSize);
}

void Release_Plugins()
{
}

HINSTANCE		hCDDriver;
CDRinit               CDR_init        =NULL;
CDRshutdown           CDR_shutdown    =NULL;
CDRopen               CDR_open        =NULL;
CDRclose              CDR_close       =NULL; 
CDRgetTN              CDR_getTN       =NULL;
CDRgetTD              CDR_getTD       =NULL;
CDRreadTrack          CDR_readTrack   =NULL;
CDRgetBuffer          CDR_getBuffer   =NULL;
CDRconfigure          CDR_configure   =NULL;
CDRabout              CDR_about       =NULL;

void LoadCDplugin()
{
	hCDDriver = LoadLibrary(Configuracion.CDRplugin);
	if(hCDDriver==NULL)
	{
                MessageBox(0, "Couln't load CD-ROM Plugin.", "ERROR", MB_ICONSTOP);
		exit(-1);
	}

    CDR_init = (CDRinit)GetProcAddress(hCDDriver,"CDRinit");
    CDR_shutdown =(CDRshutdown)GetProcAddress(hCDDriver,"CDRshutdown");  
    CDR_open=(CDRopen)GetProcAddress(hCDDriver,"CDRopen");       
    CDR_close=(CDRclose)GetProcAddress(hCDDriver,"CDRclose");        
    CDR_getTN=(CDRgetTN)GetProcAddress(hCDDriver,"CDRgetTN");
    CDR_getTD=(CDRgetTD)GetProcAddress(hCDDriver,"CDRgetTD");     
    CDR_readTrack=(CDRreadTrack)GetProcAddress(hCDDriver,"CDRreadTrack");  
    CDR_getBuffer=(CDRgetBuffer)GetProcAddress(hCDDriver,"CDRgetBuffer");   
    CDR_configure=(CDRconfigure)GetProcAddress(hCDDriver,"CDRconfigure");  
    CDR_about=(CDRabout)GetProcAddress(hCDDriver,"CDRabout");      
}

HINSTANCE		hSPUDriver;
SPUconfigure        SPU_configure      =NULL;
SPUabout            SPU_about          =NULL;
SPUinit             SPU_init           =NULL;
SPUshutdown         SPU_shutdown       =NULL;
SPUopen             SPU_open           =NULL;
SPUclose            SPU_close          =NULL;
SPUplaySample       SPU_playSample     =NULL;
SPUstartChannels1   SPU_startChannels1 =NULL;
SPUstartChannels2   SPU_startChannels2 =NULL;
SPUstopChannels1    SPU_stopChannels1  =NULL;
SPUstopChannels2    SPU_stopChannels2  =NULL;
SPUputOne           SPU_putOne         =NULL;
SPUgetOne           SPU_getOne         =NULL;
SPUsetAddr          SPU_setAddr        =NULL;
SPUsetPitch         SPU_setPitch       =NULL;
SPUsetVolumeL       SPU_setVolumeL     =NULL;
SPUsetVolumeR       SPU_setVolumeR     =NULL;
SPUwriteRegister    SPU_writeRegister  =NULL;
SPUreadRegister     SPU_readRegister   =NULL;
SPUwriteDMA         SPU_writeDMA       =NULL;
SPUreadDMA          SPU_readDMA        =NULL;
SPUplayADPCMchannel SPU_playADPCMchannel = NULL;
SPUfreeze           SPU_freeze         = NULL;

void LoadSPUplugin()
{

	hSPUDriver = LoadLibrary(Configuracion.SPUplugin);
	if(hSPUDriver==NULL)
	{
                MessageBox(0, "Couln't load SPU Plugin.", "ERROR", MB_ICONSTOP);
		exit(-1);
	}
SPU_configure = (SPUconfigure)GetProcAddress(hSPUDriver, "SPUconfigure");      
SPU_about =(SPUabout)GetProcAddress(hSPUDriver,"SPUabout");       
SPU_init =(SPUinit)GetProcAddress(hSPUDriver,"SPUinit");         
SPU_shutdown=(SPUshutdown)GetProcAddress(hSPUDriver,"SPUshutdown");      
SPU_open=(SPUopen)GetProcAddress(hSPUDriver,"SPUopen");
SPU_close=(SPUclose)GetProcAddress(hSPUDriver,"SPUclose");          
SPU_playSample=(SPUplaySample)GetProcAddress(hSPUDriver,"SPUplaySample");     
SPU_startChannels1=(SPUstartChannels1)GetProcAddress(hSPUDriver,"SPUstartChannels1"); 
SPU_startChannels2=(SPUstartChannels2)GetProcAddress(hSPUDriver,"SPUstartChannels2"); 
SPU_stopChannels1=(SPUstopChannels1)GetProcAddress(hSPUDriver,"SPUstopChannels1"); 
SPU_stopChannels2=(SPUstopChannels2)GetProcAddress(hSPUDriver,"SPUstopChannels2");  
SPU_putOne=(SPUputOne)GetProcAddress(hSPUDriver,"SPUputOne");         
SPU_getOne=(SPUgetOne)GetProcAddress(hSPUDriver,"SPUgetOne");
SPU_setAddr=(SPUsetAddr)GetProcAddress(hSPUDriver,"SPUsetAddr");        
SPU_setPitch=(SPUsetPitch)GetProcAddress(hSPUDriver,"SPUsetPitch");       
SPU_setVolumeL=(SPUsetVolumeL)GetProcAddress(hSPUDriver,"SPUsetVolumeL");     
SPU_setVolumeR=(SPUsetVolumeR)GetProcAddress(hSPUDriver,"SPUsetVolumeR");
SPU_writeRegister=(SPUwriteRegister)GetProcAddress(hSPUDriver,"SPUwriteRegister");
SPU_readRegister=(SPUreadRegister)GetProcAddress(hSPUDriver,"SPUreadRegister");
SPU_writeDMA=(SPUwriteDMA)GetProcAddress(hSPUDriver,"SPUwriteDMA");
SPU_readDMA=(SPUreadDMA)GetProcAddress(hSPUDriver,"SPUreadDMA");
SPU_playADPCMchannel=(SPUplayADPCMchannel)GetProcAddress(hSPUDriver,"SPUplayADPCMchannel");
SPU_freeze= (SPUfreeze)GetProcAddress(hSPUDriver,"SPUfreeze");
}

static void SPU__freeze(unsigned long a, void *b)
{
        if (SPU_freeze == NULL) return;
        SPU_freeze(a,b);
}

static long SPU__init()
{
	return SPU_init();
}
static long SPU__shutdown()
{
    return SPU_shutdown();
}
static long SPU__open(HWND hW)
{
	return SPU_open(hW);
}
static long SPU__close()
{
	return SPU_close();
}
void SPU__playADPCMchannel(xa_decode_t *xap)
{
        SPU_playADPCMchannel(xap);
}


static unsigned long PAD__init(int flags)
{
	return PAD_init(flags);
}	
static void PAD__shutdown(void)
{
	PAD_shutdown();
}	
static unsigned long PAD__open(HWND hW)
{
        return(PAD_open(hW));
}	
static unsigned long PAD__close(void)
{
        return(PAD_close());
}	
static unsigned long PAD__query(void)
{
        return(PAD_query());
}	
static unsigned long PAD__readPort1(PadDataS *init)
{
        return(PAD_readPort1(init));
}	
static unsigned long PAD__readPort2(PadDataS *init)
{
        return(PAD_readPort2(init));
}	

